init()
{
  // We're in the server init routine. Do stuff before the game starts.
  Precache();

  // The server may move on now so we thread the rest.
  thread SetupDvars();
  thread StartThreads();
}

PreCache()
{

}

SetupDvars()
{
	// Lets make sure were empty before we start the threads

	setdvar("b3_bro_adminspec", "");


}

StartThreads()
{
   wait .05;
   thread DvarChecker();
}

DvarChecker()
{

	while(1)
  {
    if( getdvar( "b3_bro_adminspec" ) != "" )
      thread _b3_adminspec();
    wait .1;
  }
}

///////// FUNCTIONS /////////////////

_b3_adminspec()
{
   B3PlayerNum = getdvarint("b3_bro_adminspec");
	setdvar("b3_bro_adminspec", "");

	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		
      thisPlayerNum = player getEntityNumber();
		if(thisPlayerNum == B3PlayerNum) // this is the one we're looking for
		{
			player thread _cmd_admin_spec();
		}
	}
}

_cmd_admin_spec()
{
   if(isdefined(self.sessionstate) && self.sessionstate != "playing" && !game["isMatch"]) 
   {
      self allowSpectateTeam("allies", true );

      self allowSpectateTeam( "axis", true );
      self allowSpectateTeam( "freelook", true );
      self allowSpectateTeam( "none", true );
   }
}