#include maps\mp\_utility;

run()
{  
   if(getdvar("sv_maprotation_0") == "") setdvar("sv_maprotation_0", getdvar("sv_maprotation"));
 //  if(getdvar("sv_maprotation_1") == "") setdvar("sv_maprotation_1", "gametype tdm map mp_dome gametype tdm map mp_courtyard");
 //  if(getdvar("sv_maprotation_2") == "") setdvar("sv_maprotation_2", "gametype sd map mp_seelow gametype sd map mp_outskirts");
   if(getdvar("bro_playerbasedrotations") == "") setdvar("bro_playerbasedrotations",0);
   if(getdvar("bro_pnumber_small") == "") setdvar("bro_pnumber_small",int(getdvarint("sv_maxclients") * 0.33));
   if(getdvar("bro_pnumber_medium") == "") setdvar("bro_pnumber_medium",int(getdvarint("sv_maxclients") * 0.66));
   
   level.maprot_data = [];
   
   level.mr_splayers = getdvarint("bro_pnumber_small");
   level.mr_mplayers = getdvarint("bro_pnumber_medium");
   
   level.maprot_data[0] = "small";
   level.maprot_data[1] = "medium";
   level.maprot_data[2] = "large";
   
   if(getdvar("bro_maprotation_small") == "") setdvar("bro_maprotation_small","gametype tdm map mp_dome gametype tdm map mp_courtyard");
   if(getdvar("bro_maprotation_small_current") == "") setdvar("bro_maprotation_small_current",getdvar("bro_maprotation_small"));
   
   if(getdvar("bro_maprotation_medium") == "") setdvar("bro_maprotation_medium","gametype ctf map mp_shrine gametype ctf map mp_airfield");
   if(getdvar("bro_maprotation_medium_current") == "") setdvar("bro_maprotation_medium_current",getdvar("bro_maprotation_medium"));
   
   if(getdvar("bro_maprotation_large") == "") setdvar("bro_maprotation_large","gametype sd map mp_seelow gametype sd map mp_outskirts");   
   if(getdvar("bro_maprotation_large_current") == "") setdvar("bro_maprotation_large_current",getdvar("bro_maprotation_large"));   
   /*
   if(!isDefined(game["b3_setnextmap"]))
   {
      game["b3_setnextmap"] = "";
      game["b3_setnextmapgametype"] = "";
   }   
   */
   if(!isDefined(game["b3_maprotationcurrent"]))
   {
      game["b3_maprotationcurrent"] = trim(getdvar("sv_maprotationcurrent"));
 //     setdvar("bro_maprotation_b3saved",game["b3_maprotationcurrent"]);
      game["b3_setnextmap"] = "";
      game["b3_setnextmapgametype"] = "";
   }  
   
   if(getdvarint("bro_playerbasedrotations") > 0)
   {
      wait 30;
      
      while(1)
      {
         checkMapRotation(); // update next map and gt - no need to do in _admin.gsc
         wait 10;
      }
   }
   else
   {
      level thread concatenateMapRotations();
       // update next map and gt
   }
}

checkMapRotation()
{
   if(level.players.size > level.mr_mplayers)
      mr = 2;
   else if(level.players.size > level.mr_splayers)
      mr = 1;
   else
      mr = 0;
      
   cur_size_mr = getdvar("bro_maprotation_" + level.maprot_data[mr]);
   cur_mr = getdvar("sv_maprotation");
   cur_mr_cur = trim(getdvar("sv_maprotationcurrent"));
   
   if(game["b3_setnextmap"] != "")
   {
      tmpB3String = "gametype " + game["b3_setnextmapgametype"] + " map " + game["b3_setnextmap"];
      
      if(getsubstr(cur_mr_cur,0,tmpB3String.size) == tmpB3String)
         cur_mr_cur = trim(getsubstr(cur_mr_cur,tmpB3String.size,cur_mr_cur.size));
   }
      
   
   if(cur_mr != cur_size_mr && cur_size_mr != "")
   {
      for(i=0; i != mr && i < 3; i++) // save current positions
      {
         if(cur_mr == getdvar("bro_maprotation_" + level.maprot_data[i]))
         {
            setdvar("bro_maprotation_" + level.maprot_data[i] + "_current",cur_mr_cur);
         }
      }
      
      setdvar("sv_maprotation",cur_size_mr);
      if(game["b3_setnextmap"] != "")
      {
         game["b3_maprotationcurrent"] = trim(getdvar("bro_maprotation_" + level.maprot_data[mr] + "_current"));
         setdvar("sv_maprotationcurrent","gametype " + game["b3_setnextmapgametype"] + " map " + game["b3_setnextmap"] + " " + getdvar("bro_maprotation_" + level.maprot_data[mr] + "_current"));
      }
      else
      {
         setdvar("sv_maprotationcurrent",getdvar("bro_maprotation_" + level.maprot_data[mr] + "_current"));
         game["b3_maprotationcurrent"] = trim(getdvar("sv_maprotationcurrent"));
      }
   }
   
  // setdvar("sv_maprotation",);
 //  setdvar("sv_maprotationcurrent",);

}

concatenateMapRotations()
{
   wait 2;
   cur_mr = getdvar("sv_maprotation");
   cur_mr_cur = getdvar("sv_maprotationcurrent");
   
   if(cur_mr_cur == "" && getdvarint("bro_playerbasedrotations") == 0)
   {
      checkedIdx = 0;
   
      for(i=0; i < 10; i++)
      {
         if(cur_mr == getdvar("sv_maprotation_" + i))
         {
            nextRot = getdvar("sv_maprotation_" + (i + 1));
            
            if(nextRot != "")
            {
               setdvar("sv_maprotation", nextRot);
               setdvar("sv_maprotationcurrent",nextRot);
               game["b3_maprotationcurrent"] = trim(getdvar("sv_maprotationcurrent"));
               println("## SETTING TO NEXT ROTATION");
            }
            else
            {
               setdvar("sv_maprotation", getdvar("sv_maprotation_0"));  
               setdvar("sv_maprotationcurrent",getdvar("sv_maprotation_0"));
               game["b3_maprotationcurrent"] = trim(getdvar("sv_maprotationcurrent"));
               println("## SETTING TO INITIAL ROTATION");         
            }     
            break;
         } 
      }
   }
}