runPersonalisation()
{

   
   level thread checkIconChange();
   
   level thread teamIcons();

}

checkIconChange()
{
 //  level endon("game_ended");
   
   
   clanIconImg = getClanIcon(getDvar("bro_clanicon"),false);
   prevDvarVal = getDvar("bro_clanicon");
   setdvar("bro_welcomeIcon",clanIconImg);
   
   while(1)
   {     
      clanIcon = getdvar("bro_clanicon");
            
      if(clanIcon != prevDvarVal)
      {         
         clanIconImg = getClanIcon(clanIcon, false);
         setdvar("bro_welcomeIcon",clanIconImg);    
         prevDvarVal = clanIcon;
      }
      wait 10;
   }
}

teamIcons()
{
   wait 5;
   while(1)
   {
   
      alliesDvar = getdvar("bro_clanIcon_" + game["allies"]);
      if(alliesDvar != "")
      {
         teamIcon["allies"] = getClanIcon(alliesDvar, true);
         if(teamIcon["allies"] == "notdefined")
         {
            game["icons"]["allies"] = getStockIcon(game["allies"]);
            
            if(getdvar("g_TeamIcon_Allies") != game["icons"]["allies"])
               setdvar("g_TeamIcon_Allies", game["icons"]["allies"]);
         }
         else
         {
            game["icons"]["allies"] = teamIcon["allies"];
            if(getdvar("g_TeamIcon_Allies") != teamIcon["allies"])
               setdvar("g_TeamIcon_Allies", teamIcon["allies"]);
         }
      }
      else
      {
         setdvar("bro_clanIcon_" + game["allies"], "undefined");
         stock = getStockIcon(game["allies"]);
         if(getdvar("g_TeamIcon_Allies") != stock)
            setdvar("g_TeamIcon_Allies",stock );
      }
      
      wait 3;
   
   // ------------------------------------ //   
      axisDvar = getdvar("bro_clanIcon_" + game["axis"]);
      if(axisDvar != "")
      {
         teamIcon["axis"] = getClanIcon(axisDvar, true);
         if(teamIcon["axis"] == "notdefined")
         {
            game["icons"]["axis"] = getStockIcon(game["axis"]);
            if(getdvar("g_TeamIcon_Axis") != game["icons"]["axis"])   
               setdvar("g_TeamIcon_Axis", game["icons"]["axis"]);
         }
         else
         {
            game["icons"]["axis"] = teamIcon["axis"];
            if(getdvar("g_TeamIcon_Axis") != game["icons"]["axis"])   
               setdvar("g_TeamIcon_Axis", game["icons"]["axis"]);
         }
      }
      else
      {
         setdvar("bro_clanIcon_" + game["axis"], "undefined");
         
         stock = getStockIcon(game["axis"]);
         if(getdvar("g_TeamIcon_Axis") != stock)
            setdvar("g_TeamIcon_Axis",stock );
      }
      
      wait 3;
   }
}

getClanIcon(dvarVal, returnStatus)
{
   if(!isdefined(level.clanIcons))
      setupIcons();
      
   if(dvarVal == "")
      return level.clanIcons["clan_brothers"];
      
   dvarVal = ToLower(dvarVal);
         
   foundIcon = undefined;
   
   for(i=0; i < level.clanIcons.size; i++)
   {
      if(isdefined(level.clanIcons[dvarVal]))
      {
         foundIcon = level.clanIcons[dvarVal];
         break;      
      }
   }
   
   if(isdefined(foundIcon))
      return foundIcon;
   else if(returnStatus == true)
      return "notdefined";
   else
      return level.clanIcons["clan_icon"];
}

setupIcons()
{
   level.clanIcons = [];
   level.clanIconTag = [];
   level.clanIconText = [];
   
   addClanIcon("rank_prestige9","clan_brothers","|Brothers|");
   
   
   addClanIcon("rank_msgt1", "clan_rangers", "Rangers");
   addClanIcon("rank_1stlt1", "clan_17thab", "[17th AB]");
   addClanIcon("rank_2ndlt1", "clan_1gjgr", "1. Gjgr");
   addClanIcon("rank_bgen1", "clan_1stid", "1st ID");
   addClanIcon("rank_capt1", "clan_29thid", "29th ID");
   addClanIcon("specialty_boost", "clan_34thid", "34th ID");
   
   addClanIcon("rank_prestige1", "clan_2ndrbn", "2nd RBn");
   addClanIcon("rank_ssgt1", "clan_3rdid", "3rd ID");
   addClanIcon("rank_gysgt1", "clan_45thid", "45th ID");
   addClanIcon("rank_sgtm1", "clan_504th", "504th");
   addClanIcon("rank_ltcol1", "clan_6thrbn", "6th RBn");
   addClanIcon("rank_ltgen1", "clan_75thrr", "75th RR");
   addClanIcon("rank_maj1", "clan_82ndab", "82nd AB");
   addClanIcon("rank_majgen1", "clan_bc", "Bad Company");
   addClanIcon("rank_sgt1", "clan_bh", "Black Hats");
   addClanIcon("rank_col1", "clan_htf", "Honor the Fallen");
   addClanIcon("rank_pvt1", "clan_para", "|PARA|");
   addClanIcon("rank_pfc1", "clan_pzgr3", "PzgR3");
   addClanIcon("rank_prestige2", "clan_trnet", "TacticalRealism.net");
   addClanIcon("rank_prestige3", "clan_thefirm", "The Firm");
   addClanIcon("rank_prestige4", "clan_cru", "{CRU}");
   addClanIcon("rank_prestige5", "clan_ssd", "|SSD|");
   addClanIcon("rank_prestige6", "clan_b2k", "|>B2K<|");
   addClanIcon("rank_prestige7", "clan_oss", "*OSS*");
   addClanIcon("rank_prestige8", "clan_101st", "101st");
   addClanIcon("specialty_ordinance", "clan_bhc", "{BHC}");
   addClanIcon("specialty_leadfoot", "clan_ezssd", "=EZ= / SSD");
   addClanIcon("specialty_twoprimaries", "clan_czp", "|CZP|");
   addClanIcon("specialty_water_cooled", "clan_ez", "=EZ=");
 //  addClanIcon("rank_cpl1", "clan_2ndmr", "2nd Marine Raiders");
   addClanIcon("rank_cpl1", "clan_1ebpc", "1eBPC");
   
    
   addClanIcon("clan_icon", "clan_icon", "Clan Icon");  // blank image 
   
   addClanIcon(getStockIcon(game["allies"]), "clan_stockallies", "Stock Allied");  
   addClanIcon(getStockIcon(game["axis"]), "clan_stockaxis", "Stock Axis");                      
/*
   
   level.clanIcons["clan_brothers"] = "rank_prestige9"; level.clanIconTag[1] = "clan_brothers"; level.clanIconText[1] = "|Brothers|";
   
   level.clanIcons["clan_rangers"] = "rank_msgt1";    level.clanIconTag[2] = "clan_rangers"; level.clanIconText[2] = "Rangers";
   level.clanIcons["clan_17thab"] = "rank_1stlt1";    level.clanIconTag[3] = "clan_17thab";  level.clanIconText[3] = "[17th AB]";
   level.clanIcons["clan_1gjgr"] = "rank_2ndlt1";     level.clanIconTag[4] = "clan_1gjgr";   level.clanIconText[4] = "1. Gjgr";
   level.clanIcons["clan_1stid"] = "rank_bgen1";      level.clanIconTag[5] = "clan_1stid";   level.clanIconText[5] = "1st ID";
   level.clanIcons["clan_29thid"] = "rank_capt1";     level.clanIconTag[6] = "clan_29thid";  level.clanIconText[6] = "29th ID";
   level.clanIcons["clan_34thid"] = "specialty_boost";   level.clanIconTag[7] = "clan_34thid";  level.clanIconText[7] = "34th ID";
   
   level.clanIcons["clan_2ndrbn"] = "rank_prestige1"; level.clanIconTag[8] = "clan_2ndrbn";  level.clanIconText[8] = "2nd RBn";
   level.clanIcons["clan_3rdid"] = "rank_ssgt1";      level.clanIconTag[9] = "clan_3rdid";   level.clanIconText[9] = "3rd ID";
   level.clanIcons["clan_45thid"] = "rank_gysgt1";    level.clanIconTag[10] = "clan_45thid"; level.clanIconText[10] = "45th ID";
   level.clanIcons["clan_504th"] = "rank_sgtm1";      level.clanIconTag[11] = "clan_504th";  level.clanIconText[11] = "504th";
   level.clanIcons["clan_6thrbn"] = "rank_ltcol1";    level.clanIconTag[12] = "clan_6thrbn"; level.clanIconText[12] = "6th RBn";
   level.clanIcons["clan_75thrr"] = "rank_ltgen1";    level.clanIconTag[13] = "clan_75thrr"; level.clanIconText[13] = "75th RR";
   level.clanIcons["clan_82ndab"] = "rank_maj1";      level.clanIconTag[14] = "clan_82ndab"; level.clanIconText[14] = "82nd AB";
   level.clanIcons["clan_bc"] = "rank_majgen1";       level.clanIconTag[15] = "clan_bc";     level.clanIconText[15] = "Bad Company";
   level.clanIcons["clan_bh"] = "rank_sgt1";          level.clanIconTag[16] = "clan_bh";     level.clanIconText[16] = "Black Hats";
   level.clanIcons["clan_htf"] = "rank_col1";         level.clanIconTag[17] = "clan_htf";    level.clanIconText[17] = "Honor the Fallen";
   level.clanIcons["clan_para"] = "rank_pvt1";        level.clanIconTag[18] = "clan_para";   level.clanIconText[18] = "|PARA|";
   level.clanIcons["clan_pzgr3"] = "rank_pfc1";       level.clanIconTag[19] = "clan_pzgr3";  level.clanIconText[19] = "PzgR3";
   level.clanIcons["clan_trnet"] = "rank_prestige2";       level.clanIconTag[20] = "clan_trnet";  level.clanIconText[20] = "TacticalRealism.net";
   level.clanIcons["clan_thefirm"] = "rank_prestige3";       level.clanIconTag[21] = "clan_thefirm";  level.clanIconText[21] = "The Firm";
   level.clanIcons["clan_cru"] = "rank_prestige4";       level.clanIconTag[22] = "clan_cru";  level.clanIconText[22] = "{CRU}";
   level.clanIcons["clan_ssd"] = "rank_prestige5";       level.clanIconTag[23] = "clan_ssd";  level.clanIconText[23] = "|SSD|";
   level.clanIcons["clan_b2k"] = "rank_prestige6";       level.clanIconTag[24] = "clan_b2k";  level.clanIconText[24] = "|>B2K<|";
   level.clanIcons["clan_oss"] = "rank_prestige7";       level.clanIconTag[25] = "clan_oss";  level.clanIconText[25] = "*OSS*";
   level.clanIcons["clan_101st"] = "rank_prestige8";       level.clanIconTag[26] = "clan_101st";  level.clanIconText[26] = "101st";
   level.clanIcons["clan_bhc"] = "specialty_ordinance";       level.clanIconTag[27] = "clan_bhc";  level.clanIconText[27] = "{BHC}";
   level.clanIcons["clan_ezssd"] = "specialty_leadfoot";       level.clanIconTag[28] = "clan_ezssd";  level.clanIconText[28] = "=EZ= / SSD";
   level.clanIcons["clan_czp"] = "specialty_twoprimaries";       level.clanIconTag[29] = "clan_czp";  level.clanIconText[29] = "|CZP|";
   level.clanIcons["clan_ez"] = "specialty_water_cooled";       level.clanIconTag[30] = "clan_ez";  level.clanIconText[30] = "=EZ=";
   level.clanIcons["clan_2ndmr"] = "rank_cpl1";       level.clanIconTag[31] = "clan_2ndmr";   level.clanIconText[31] = "2nd Marine Raiders";
   
   
   level.clanIcons["clan_icon"] = "clan_icon";        level.clanIconTag[level.clanIconTag.size+1] = "clan_icon";   level.clanIconText[level.clanIconText.size+1] = "Clan Icon";  // blank image 
   
   level.clanIcons["clan_stockallies"] = getStockIcon(game["allies"]);        level.clanIconTag[level.clanIconTag.size+1] = "clan_stockallies";   level.clanIconText[level.clanIconText.size+1] = "Stock Allied";  
   level.clanIcons["clan_stockaxis"] = getStockIcon(game["axis"]);        level.clanIconTag[level.clanIconTag.size+1] = "clan_stockaxis";   level.clanIconText[level.clanIconText.size+1] = "Stock Axis";                      
*/
}

addClanIcon(material,dvar,name)
{
   idx = level.clanIcons.size + 1;
   
   level.clanIcons[dvar] = material;
   level.clanIconTag[idx] = dvar;
   level.clanIconText[idx] = name;
}

getStockIcon(team)
{
   switch(team)
   {
      case "russian": 
         return "faction_128_soviet";
      case "german":
         return "faction_128_german";
      case "japanese":
         return "faction_128_japan";
      case "marines":
      default:
         return "faction_128_american";
   }
}