#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

//////////////////
//    HUD Stuff
//////////////////

opHud(type)
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("radiohudcleaned");
//	self endon("disconnect");
	self endon("death_or_disconnect");
	self endon("perks_hidden");
	level endon("intermission");
	level endon("game_ended");
	   
   if(!isdefined(self.radioStatus))
   {
      self.radioStatus = newClientHudElem(self);
      self.radioStatus.horzAlign = "left";
      self.radioStatus.vertAlign = "top";
      self.radioStatus.x = 160;
      self.radioStatus.y = 5;
      self.radioStatus.alignX = "left";
      self.radioStatus.alignY = "top";
      self.radioStatus.color = (1,1,1);
      self.radioStatus.archived = false; 
   }
   
   if(type == "arty_radio_mp")
      self.radioStatus setshader("compass_objpoint_flak",20,20);
   else
      self.radioStatus setshader("hud_icon_flare",20,20);
 //  else
 //     self.radioStatus destroy();
 /*     
   if(!isdefined(self.statusLabel))
   {
      self.statusLabel = newClientHudElem(self);
      self.statusLabel.horzAlign = "left";
      self.statusLabel.vertAlign = "top";
      self.statusLabel.x = 183;
      self.statusLabel.y = 10;
      self.statusLabel.alignX = "left";
      self.statusLabel.alignY = "top";
      self.statusLabel.font = "default";
      self.statusLabel.fontscale = 1;
      self.statusLabel.archived = false;
   }
   */
   team = self.pers["team"];

   while(isdefined(self.radioStatus))
   {
      weapon = self GetCurrentWeapon();
      if(weapon == type)
      {
   //      self.statusLabel settext(&"BRM_CHECK_ARTY_STATUS");
         self setclientdvars("ui_statustext",4);
   //      if(isdefined(self.statusLabel))
   //         self.statusLabel.alpha = 1;
         
         while(game["artyStrikes"][team]["isfiring"])
         {
            self.artyStatus = 2;
            
            self.radioStatus.color = (0.66,0,0);
            
            self.radioStatus.alpha = 0.2;
            
            for(i=0; game["artyStrikes"][team]["isfiring"] && i<10; i++)
            {
               wait 0.05;
               self.radioStatus.alpha += 0.08;
            }
            for(i=0; game["artyStrikes"][team]["isfiring"] && i<10; i++)
            {
               wait 0.05;
               self.radioStatus.alpha -= 0.08;
            }                        
            self.artyStatus = 4; 
         }
         
         self.radioStatus.alpha = 1;
         
         if(self.artyStatus == 0)
         {
            self.radioStatus.color = (0.66,0,0);       
         }
         else if(self.artyStatus == 1)
         {
            self.radioStatus.color = (1, 0.94, 0.4);       
         }
         else if(self.artyStatus == 3)
         {
            self.radioStatus.color = (0.5, 1, 0);         
         }
         else if(self.artyStatus == 4)
         {
            self.radioStatus.color = (1,1,1);        
         }
      }
      else
      {
         
       //  if(isdefined(self.statusLabel) && !isSubStr(weapon,"bipod_mp") && weapon != "mortar_mp")
         if(!isDefined(self.targetMortar) && !isDefined(self.targetTurret) && weapon != "mortar_mp" && !issubstr(weapon,"bipod") && weapon != "ptrs41_mp")
         {
      //      self.statusLabel.alpha = 0;
            self setclientdvars("ui_statustext",0);
         }
         
      }
      wait 0.2;
   }
}

////////////////////////////////////
//    Calling Functions (Radioman)
////////////////////////////////////

getArtyStatus()
{
   team = self.pers["team"];
   
   if(game["artyStrikes"][team]["max"] == 0)
   {
      self.artyStatus = 0;
      self iprintlnbold(&"MSBRM_NO_ARTY_AMMO");
    //  self playLocalSound("brm_radio_artillery_ready");
      self thread playArtySounds("notready");
   }
   else if(game["artyStrikes"][team]["cooldown"] > 0)
   {
      self.artyStatus = 1;
      self iprintlnbold(&"MSBRM_ARTY_REARMING");
    //  self playLocalSound("brm_radio_artillery_reloading");
      self thread playArtySounds("notready");
   }
   else if(game["artyStrikes"][team]["cooldown"] <= 0)
   {
      self iprintlnbold(&"MSBRM_ARTY_READY");
      self playLocalSound("brm_radio_artillery_ready");
      self thread playArtySounds("ready");
      self.artyStatus = 3;      
   }
}

callFireMission()
{
   if(level.debugExtra) 
      self.coordinates["artillery"] = self.origin;

   if(!isdefined(self.coordinates["artillery"]))
   {
      self iprintlnbold(&"MSBRM_NO_ARTY_COORDS");
      self iprintlnbold(&"MSBRM_FIND_OFFICER");
   }  
   else if(game["artyStrikes"][self.pers["team"]]["max"] <= 0)
   {
      self iprintlnbold(&"MSBRM_NO_ARTY");   
     // self playLocalSound("brm_radio_artillery_ready");  
      self thread playArtySounds("notready");
   }
   else if(game["artyStrikes"][self.pers["team"]]["cooldown"] > 0)
   {
      self iprintlnbold(&"MSBRM_ARTY_BATTERY_REARMING");  
  //    self playLocalSound("brm_radio_artillery_ready"); 
      self thread playArtySounds("notready");    
   }
   else
   {
   //   self playLocalSound("brm_radio_artillery_fire");
      self thread playArtySounds("firing");
      game["artyStrikes"][self.pers["team"]]["max"]--;
      game["artyStrikes"][self.pers["team"]]["cooldown"] = level.artycooldown;
      tmp = self.coordinates["artillery"];
      officer = self.officer["artillery"];

      self.coordinates["artillery"] = undefined;
      self.officer["artillery"] = undefined;
      
      maps\mp\gametypes\_globallogic::givePlayerScore( "radiomanreward", self );
      self maps\mp\gametypes\_globallogic::incPersStat( "assists", 1 );
      self.assists = self maps\mp\gametypes\_globallogic::getPersStat( "assists" );
      thread globalRefresh(self.pers["team"],"artyStrikes");
      
      self notifySpecialties("artillery");
      thread globalRefresh(self.pers["team"], "artyStrikes");
      
      
      wait 4;
      if(level.debugExtra) 
         self thread maps\mp\gametypes\_hardpoints::useArtillery( tmp );
      else
         officer thread maps\mp\gametypes\_hardpoints::useArtillery( tmp );   // Roger that ;-)
      
   }
}

callAirSupport()
{
   if(level.airSupportHash > 0)
   {
      if(level.debugExtra)
      {
         bombingData["type"] = "napalm";
         bombingData["targetpos"] = self.origin;

         bombingData["entrypos"] = self.origin + (10,1,0);
         
         self.coordinates["airsupport"] = bombingData;
         self.radioSupportCategory = "napalm";
      }
   
      if(!isdefined(self.coordinates["airsupport"]))
      {  
         self iprintlnbold(&"MSBRM_AIR_NEED_OFFICER");
      }
      else if(game[self.radioSupportCategory][self.pers["team"]]["max"] <= 0)
      {
         if(self.radioSupportCategory == "bomb")
            self iprintlnbold(&"MSBRM_NO_MORE_BOMBING");
         else if(self.radioSupportCategory == "napalm")
            self iprintlnbold(&"MSBRM_NO_MORE_NAPALM");
         else if(self.radioSupportCategory == "phos")
            self iprintlnbold(&"MSBRM_NO_MORE_PHOS");
         else
            self iprintlnbold(&"MSBRM_NO_MORE_STRAFING");   
        
         self thread playArtySounds("airsupportnotavail");
      }
      else if(game["airsupport"][self.pers["team"]]["cooldown"] > 0)
      {
         self iprintlnbold(&"MSBRM_AIR_SUPPORT_NOTAVAILABLE");    
         self thread playArtySounds("airsupportnotavail");
      }
      else
      {
         type = self.radioSupportCategory;
         coords = self.coordinates["airsupport"];
         officer = self.officer["airsupport"];
         game[type][self.pers["team"]]["max"]--;
         
         if(!level.debugExtra)  
            game["airsupport"][self.pers["team"]]["cooldown"] = level.airsupportCooldown + level.airsupportpredelay;
         self.coordinates["airsupport"] = undefined;
         self.officer["airsupport"] = undefined;
         self.radioSupportCategory = undefined;
         
         maps\mp\gametypes\_globallogic::givePlayerScore( "radiomanreward", self );
         self maps\mp\gametypes\_globallogic::incPersStat( "assists", 1 );
         self.assists = self maps\mp\gametypes\_globallogic::getPersStat( "assists" );
         thread globalRefresh(self.pers["team"], "airsupport");
         
         self notifySpecialties(type);
         
         wait 2;
         
         if(!level.debugExtra)  
            wait level.airsupportpredelay;
         
         if(type == "bomb")
         {
            level thread maps\mp\gametypes\_airsupport::bombingRun(self.pers["team"],coords,officer);   // Roger that ;-)     
         }
         else if(type == "napalm")
         {
            level thread maps\mp\gametypes\_airsupport::bombingRun(self.pers["team"],coords,officer);   // Roger that ;-)     
         }
         else if(type == "strafing")
         {
            level thread maps\mp\gametypes\_strafingplanes::doStrafe(self.pers["team"], 999,officer);   // Roger that ;-)   
         }
         else if(type == "phos")
         {
            level thread maps\mp\gametypes\_airsupport::bombingRun(self.pers["team"],coords,officer);   // Roger that ;-)   
         }
      }
   }
}

callSupplyDrop()
{
   if(!isdefined(self.coordinates["supplies"]))
   {
      self iprintlnbold(&"MSBRM_NO_SUPPLY_COORDS");
      self iprintlnbold(&"MSBRM_FIND_OFFICER");
   }  
   else if(game["supplyDrops"][self.pers["team"]]["max"] <= 0)
   {
      self iprintlnbold(&"MSBRM_NO_MORE_SUPPLY");     
   }
   else if(game["supplyDrops"][self.pers["team"]]["cooldown"] > 0)
   {
      self iprintlnbold(&"MSBRM_SUPPLY_REFUEL");       
   }
   else
   {
      self thread playArtySounds("supplydropincoming"); 
  //    self thread doSupplyDrop(self.coordinates["supplies"]);    // inbound!
      self thread maps\mp\gametypes\_supplydrops::doSupplyDrop(self.coordinates["supplies"]);    // inbound!
      game["supplyDrops"][self.pers["team"]]["max"]--;
      game["supplyDrops"][self.pers["team"]]["cooldown"] = level.supplyDropCooldown + 31;
      self.coordinates["supplies"] = undefined;
      self notifySpecialties("supplies");
      thread globalRefresh(self.pers["team"], "supplyDrops");
      
      maps\mp\gametypes\_globallogic::givePlayerScore( "radiomanreward", self );
      self maps\mp\gametypes\_globallogic::incPersStat( "assists", 1 );
      self.assists = self maps\mp\gametypes\_globallogic::getPersStat( "assists" );
   } 
}

callSmokeBarrage()
{
   if(level.debugExtra) 
      self.coordinates["smokebarrage"] = self.origin;
      
   if(!isdefined(self.coordinates["smokebarrage"]))
   {
      self iprintlnbold(&"MSBRM_NO_SMOKE_COORDS");
      self iprintlnbold(&"MSBRM_FIND_OFFICER");
   }  
   else if(game["smokebarrage"][self.pers["team"]]["max"] <= 0)
   {
      self iprintlnbold(&"MSBRM_NO_MORE_SMOKE");     
   }
   else if(game["smokebarrage"][self.pers["team"]]["cooldown"] > 0)
   {
      self iprintlnbold(&"MSBRM_MORTAR_REARMING");       
   }
   else
   {
      //self thread playArtySounds("supplydropincoming"); 
  //    self thread doSupplyDrop(self.coordinates["supplies"]);    // inbound!
 //     self thread maps\mp\gametypes\_supplydrops::doSupplyDrop(self.coordinates["supplies"]);    // inbound!
      self thread maps\mp\gametypes\_mortars::smokeBarrage(self.coordinates["smokebarrage"], self.pers["team"], self.origin);
      game["smokebarrage"][self.pers["team"]]["max"]--;
      game["smokebarrage"][self.pers["team"]]["cooldown"] = level.smokeBarrageCooldown + 31;
      self.coordinates["smokebarrage"] = undefined;
      self notifySpecialties("smokebarrage");
      thread globalRefresh(self.pers["team"],"smokebarrage");
      
      maps\mp\gametypes\_globallogic::givePlayerScore( "radiomanreward", self );
      self maps\mp\gametypes\_globallogic::incPersStat( "assists", 1 );
      self.assists = self maps\mp\gametypes\_globallogic::getPersStat( "assists" );
   } 
}

/////////////////////////////
//    Menu Functions 
/////////////////////////////

refreshChoices(type)
{
   if(type == "officer" || type == "artyStrikes")
   {
      if(game["artyStrikes"][self.pers["team"]]["max"] > 0)
         self setClientdvars("bro_ui_artyavailable",game["artyStrikes"][self.pers["team"]]["cooldown"]);       
      else
         self setClientdvars("bro_ui_artyavailable",-1); 
   }
   if(type == "officer" || type == "airsupport")
   {
      self setClientdvars("bro_airsupportactive",(limitVar(game["strafing"][self.pers["team"]]["max"],0,1) + (limitVar(game["bomb"][self.pers["team"]]["max"],0,1) * 10) + (limitVar(game["napalm"][self.pers["team"]]["max"],0,1) * 100) + (limitVar(game["phos"][self.pers["team"]]["max"],0,1) * 10000)),
                           "bro_ui_airsupportavailable",game["airsupport"][self.pers["team"]]["cooldown"] );
   }
   if(type == "officer" || type == "nco" || type == "mortarbarrage") 
   {
      
      if(game["mortarbarrage"][self.pers["team"]]["max"] > 0 && 
         ((getdvarint("bro_squads_mortar_officer") > 0 && self.hasArtyBinoculars) || 
         (getdvarint("bro_squads_mortar_nco") > 0 && self.hasNcoBinoculars))
         )
         self setClientdvars("bro_ui_mortaravailable",game["mortarbarrage"][self.pers["team"]]["cooldown"]);       
      else
         self setClientdvars("bro_ui_mortaravailable",-1); 
   }
   if(type == "smokebarrage" || type == "nco" || type == "supplyDrops")
   {
      if(game["smokebarrage"][self.pers["team"]]["max"] > 0)
         self setClientDvars("bro_ui_smokeavailable", game["smokebarrage"][self.pers["team"]]["cooldown"]);
      else
         self setClientDvars("bro_ui_smokeavailable", -1);
         
      if(game["supplyDrops"][self.pers["team"]]["max"] > 0)
         self setClientDvars("bro_ui_supplyavailable", game["supplyDrops"][self.pers["team"]]["cooldown"]);
      else
         self setClientDvars("bro_ui_supplyavailable", -1);
   }
   if(type == "radioop")
   { 
      if(isdefined(self.coordinates["smokebarrage"]))
         self setclientDvars("bro_ui_cancallsmoke",1);
      else
         self setclientDvars("bro_ui_cancallsmoke",0);
      
      if(isdefined(self.coordinates["artillery"]))
         self setclientDvars("bro_ui_cancallarty",1);
      else
         self setclientDvars("bro_ui_cancallarty",0);
         
      if(isdefined(self.coordinates["supplies"]))
         self setclientDvars("bro_ui_cancallsupply",1);
      else
         self setclientDvars("bro_ui_cancallsupply",0);
   
      if(game["strafing"][self.pers["team"]]["max"] > 0 ||
         game["bomb"][self.pers["team"]]["max"] > 0 ||
         game["napalm"][self.pers["team"]]["max"] > 0 ||
         game["phos"][self.pers["team"]]["max"] > 0) 
      {
            if(isDefined(self.coordinates["airsupport"]))
               self setClientDvars("bro_ui_cancallair",1);
            else
               self setClientDvars("bro_ui_cancallair",0);
      }
      else
         self setClientDvars("bro_ui_cancallair",-1);
   }
}

globalRefresh(team, category)
{  
   if(category == "artyStrikes" || category == "airsupport" || category == "supplyDrops" || category == "smokebarrage" || category == "mortarbarrage")
   {
      for(i=0; i<level.players.size; i++)
      {
         plr = level.players[i];
         
         if(isDefined(plr.pers["team"]) && plr.pers["team"] == team && isAlive(plr) && (plr.hasNcoBinoculars || plr.hasArtyBinoculars))
            plr refreshChoices(category);
      }
   }
}

/////////////////////////////
//    Officer Functions 
/////////////////////////////

getCoordinates(type)
{
   if(self GetCurrentWeapon() == "binoculars_mp" && self PlayerAds() > 0.7)
   {
      // Code nicked from Single player dpad_assets I think
      
      // Trace to where the player is looking
      direction = self getPlayerAngles();
      direction_vec = anglesToForward( direction );
      
      if(!isdefined(self.eyemarker)) // geteye() is a bit borked :-S
      {
         self.eyemarker = spawn("script_origin",(0,0,0));
         self.eyemarker linkto (self, "tag_eye",(0,0,0),(0,0,0));
         wait 0.05;
      }
      
      eye = self.eyemarker.origin;
          
      // offset 2 units on the Z to fix the bug where it would drop through the ground sometimes
      trace = bullettrace( eye, eye + vector_scale( direction_vec , 8000 ), 0, undefined );
      trace2 = bullettrace(  trace["position"]+(0,0,2),  trace["position"] - (0,0,100000), 0, undefined );

      // so the trace doesnt go so low and create huge values for the network
      tracepos = trace2["position"];
      if (tracepos[2] < -650)
      {
         tracepos = (tracepos[0], tracepos[1], -650);
         trace2["position"] = tracepos;       
      }
      
      // move the drop coordinates back a bit so the box doesn't land on a silly ledge or something
      if(type == "supplies")
         trace2["position"] = trace2["position"] - vector_scale( direction_vec , 150 );
         
    //  self thread maps\mp\gametypes\_supplydropzeroy::doSupplyDrop(trace2["position"]);

      if((type == "artillery" || type == "mortarbarrage") && !level.artyDangerClose)
      {
         close = maps\mp\gametypes\_hardpoints::pointIsInAirstrikeArea(self.origin,trace2["position"],0);
         
         if(close)
         {
            self iprintlnbold(&"MSBRM_COORDS_ON_HEAD");
            return;
         }
      }    
      if(type == "mortarbarrage" && bombsiteRestricted(self.pers["team"],trace2["position"]))
      {
         self iprintlnbold(&"MSBRM_NO_ON_BOMBSITE");
         return;
      }
      giveCoordinates(trace2["position"], type);   
   }
   else
   {
      self iprintlnbold(&"MSBRM_AIM_BINOS");
   }
}

mapSelection(type)
{

	self beginLocationSelection( "map_artillery_selector", level.commandSelectionCursorSize );
//	self beginLocationSelection( "map_squad_command" );
	self.selectingLocation = true;

	self thread endSelectionOn( "cancel_location" );
	self thread endSelectionOn( "death" );
	self thread endSelectionOn( "disconnect" );
	self thread endSelectionOn( "used" );
	self thread endSelectionOnGameEnd();

	self endon( "stop_location_selection" );

	self setClientDvars("ui_bombhelptext","MSBRM_MARK_TARGET");
//	self.bombingData = [];
//	self.bombingData["type"] = type;
	
	clicks = false;
	
	if(type == "mortarbarrage")
   {
      self waittill( "confirm_location", location );
      if(!bombsiteRestricted(self.pers["team"],location))
      {
         self thread giveCoordinates(location,type);
      }
      else
      {
         self iprintlnbold(&"MSBRM_NO_ON_BOMBSITE");
      }
      
   }     
	else
	{
      while(1)
      {
         self waittill( "confirm_location", location );
         
         if(!clicks)
         {
            self.bombingData = [];
            self.bombingData["type"] = type;
            self.bombingData["targetpos"] = location;
            self iprintln(&"MSBRM_MARKED_TARGET");
            self setClientDvars("ui_bombhelptext","MSBRM_MARK_ENTRY");
         }
         else
         {
            self.bombingData["entrypos"] = location;
            self thread giveCoordinates(self.bombingData,type);
            break;
         }  
         clicks = true;

         self thread pausePlace();
              
         self waittill("can_click_again");
      }
   }
   
   self thread stopHardpointLocationSelection( false );
}

markMortar()
{
   if( (getdvarint("bro_squads_mortar_officer") > 0 && self.hasArtyBinoculars) ||
   (getdvarint("bro_squads_mortar_nco") > 0 && self.hasNcoBinoculars) )
   {
      if(game["mortarbarrage"]["allies"]["cooldown"] > 0)
      {
         self iprintlnBold(&"MSBRM_PLEASE_WAIT", game["mortarbarrage"][self.pers["team"]]["cooldown"]);
      }
      else if(game["mortarbarrage"][self.pers["team"]]["max"] > 0)
      {
         if(getdvarint("bro_squads_mortar_usebinoculars") > 0)
            self thread getCoordinates("mortarbarrage");
         else
            self thread mapSelection("mortarbarrage");      
      }
      else
      {
         self iprintlnBold(&"MSBRM_NO_MORE_MORTAR");
         self thread giveCoordinates(self.origin,"mortarbarragena");
      }
   }
}

bombsiteRestricted(team,pos)
{
   radius = getdvarint("bro_squads_mortar_bombsite_saferange");
   
   if(radius <= 0 || level.gametype != "sd")
      return false;
      /*
   for(i=0; i < level.bombzonePoints.size; i++)
   {
      if(self.pers["team"] == game["defenders"])
      {
         if(distance2D(pos, level.bombzonePoints[i].pos) <= radius)
            return true;
      }
      else if(self.pers["team"] == game["attackers"] && level.bombzonePoints[i].team == "all")
      {
         if(distance2D(pos, level.bombzonePoints[i].pos) <= radius)
            return true;
      }
   }*/
   
   bombZones = getEntArray( "bombzone", "targetname" );
   
   for(i=0; i < bombZones.size; i++)
   {
      if(self.pers["team"] == game["defenders"])
      {
         if(distance2D(pos, bombZones[i].origin) <= radius)
            return true;
      }
      else if(self.pers["team"] == game["attackers"] && bombZones[i].team == "all")
      {
         if(distance2D(pos, bombZones[i].origin) <= radius)
            return true;
      }
   }
   
   return false;
}

giveCoordinates(pos, type)
{  
   if(level.debugExtra)
   {
      if(type=="supplies")
      {
         self thread maps\mp\gametypes\_supplydrops::doSupplyDrop(pos); 
         self thread playArtySounds("supplydropincoming"); 
      }
      else if(type=="strafing")
      {
         level thread maps\mp\gametypes\_strafingplanes::doStrafe(self.pers["team"], 999, self);     
      }
      else if(type == "bomb" || type == "napalm" || type == "phos")
      {
        // level thread maps\mp\gametypes\_airsupport::bombingRun(self.pers["team"],"bomb",self.bombingData,self);
         level thread maps\mp\gametypes\_airsupport::bombingRun(self.pers["team"],self.bombingData,self);
      }
      else if(type == "smokebarrage")
      {
       //  level thread maps\mp\gametypes\_mortars::firemortar(self.bombingData["targetpos"],self.origin + (0,0,20),"ex");
       
         level thread maps\mp\gametypes\_mortars::smokeBarrage(pos, self.pers["team"], self.origin);
      }
      else if(type == "mortarbarrage")
      {
         self thread maps\mp\gametypes\_hardpoints::useArtillery( pos );  
      }
      else
      {
         self thread maps\mp\gametypes\_hardpoints::useArtillery( pos );  

       //  self playLocalSound("brm_radio_artillery_fire");
       //  self thread play_sound_on_tag( "brm_radio_artillery_fire", "tag_inhand" );
         self thread playArtySounds("firing");
      }
      
      self notifySpecialties(type);
      
      return;     
   }
   
   if(type == "mortarbarrage" || type == "mortarbarragena")
      target = self nearMortarOp();
   else
      target = self nearRadioOp();
   
   if(!isdefined(target) || target == self)
   {
      if(type == "mortarbarrage")
         self iprintlnbold(&"MSBRM_NOT_NEAR_MORTAR");
      else if(type != "mortarbarragena")
         self iprintlnbold(&"MSBRM_NOT_NEAR_RADIO");  // fool!
      return;
   }
   
   if(type == "mortarbarragena")
   {
      target iprintlnbold(&"MSBRM_NO_MORE_MORTAR");
      return;
   }
   
   switch(type)            // Might add some more stuff in at some point (strafing, bombing, kamikaze)
   {
      case "supplies":
         phrase = "supply drop";
         self iprintln(&"MSBRM_PLR_HAS_SUPPLY_COORDS", target);
         target iprintln(&"MSBRM_YOU_HAVE_SUPPLY_COORDS", self);
         break;
      case "artillery":
         self iprintln(&"MSBRM_PLR_HAS_ARTY_COORDS", target);
         target iprintln(&"MSBRM_YOU_HAVE_ARTY_COORDS", self);
         break;
      case "bomb":
         self iprintln(&"MSBRM_PLR_ORDER_BOMBING", target);
         target iprintln(&"MSBRM_ORDER_AIR_SUPPORT", self);
         break;
      case "strafing":
         self iprintln(&"MSBRM_PLR_ORDER_STRAFING", target);
         target iprintln(&"MSBRM_ORDER_AIR_SUPPORT", self);
         break;
      case "napalm":
         self iprintln(&"MSBRM_PLR_ORDER_NAPALM", target);
         target iprintln(&"MSBRM_ORDER_AIR_SUPPORT", self);
         break;
      case "phos":
         self iprintln(&"MSBRM_PLR_ORDER_PHOS", target);
         target iprintln(&"MSBRM_ORDER_AIR_SUPPORT", self);
         break;
      case "mortarbarrage":
         self iprintln(&"MSBRM_PLR_ORDER_MORTAR", target);
         target iprintln(&"MSBRM_ORDER_MORTAR", self);
         break;
      case "smokebarrage":
         self iprintln(&"MSBRM_PLR_ORDER_SMOKE", target);
         target iprintln(&"MSBRM_ORDER_SMOKE", self);
         break;
      default:
         self iprintln("^3" + target.name + " has your marked " + type + " coordinates");
         target iprintln("^3" + self.name + " has given you valid " + type + " coordinates");
         break;
   }
   
   if(type == "strafing" || type == "bomb" || type == "napalm" || type == "phos")
   {
      target.radioSupportCategory = type;   
      type = "airsupport";
   }
   
   if(type == "mortarbarrage")
   {
      if(isDefined(target.coordinates[type]))
         target iprintlnbold(&"MSBRM_MORTAR_TARGET_CHANGE");
      else
         target._mortarBarrageShells = level._mortarBarrageShells;
      
      target.coordinates[type] = pos;
         
      if(isDefined(target.mortar))
      {
         point = maps\mp\gametypes\_mortars::getRelMapPoint(target.coordinates["mortarbarrage"]);
         // set allowed number of shells.         
         target setClientDvars("bro_ui_mortar_targareax",limitvar(point[0],0,180) - level._mortarTargetAreaRad,
                        "bro_ui_mortar_targareay",limitvar(point[1],0,180) - level._mortarTargetAreaRad,
                        "bro_ui_mortar_targareasize",(level._mortarTargetAreaRad * 2));
         
         if(isDefined(target.mortarHudMenuStatus))
         {              
            target.mortarHudMenuStatus.color = (0.35, 1, 0);
            target.mortarHudMenuStatus setText( &"BRM2_MORTAR_READY_SHELLS",target._mortarBarrageShells);
         }
      }
   }
   else
   {
      target.coordinates[type] = pos;
      target.officer[type] = self;
      target maps\mp\gametypes\_radiooperations::refreshChoices("radioop");
   }
}

nearRadioOp()
{
   for(i=0; i<level.players.size; i++)
   {
      if(level.players[i].pers["team"] == self.pers["team"] && level.players[i] hasWeapon( "arty_radio_mp" ))
      {
         if(distance(level.players[i].origin, self.origin) < getdvarint("bro_squads_officer_radioman_dist"))
         {
            return level.players[i];
         }    
      }
   }
   return self;
}

nearMortarOp()
{
   for(i=0; i<level.players.size; i++)
   {
      if(level.players[i].pers["team"] == self.pers["team"] && (level.players[i] hasWeapon( "mortar_mp" ) || isDefined(level.players[i].mortar)))
      {
         if(distance(level.players[i].origin, self.origin) < getdvarint("bro_squads_officer_mortar_dist"))
         {
            return level.players[i];
         }    
      }
   }
   return self;
}

playArtySounds(type)
{
   switch(type)
   {
      case "ready":
         alias = "brm_radio_artillery_ready" + randomint(8);
         break;
      case "firing":
         alias = "brm_radio_artillery_fire" + randomint(5);
         break;    
      case "notready":
         alias = "brm_radio_artillery_reloading" + randomint(2);
         break;     
      case "airsupportnotavail":
         alias = "brm_radio_airsupport_notready0";
         break;
      case "supplydropincoming":
         alias = "brm_radio_supplydrop_incoming0";
         break;
      default: 
         return;
   }
   
   self playLocalSound(alias);
   self playsound(alias);
}

notifySpecialties(type)
{
   switch(type)           
   {
      case "supplies":
         msg = &"MSBRM_SUPPLY_OTW";
         break;
      case "artillery":
         msg = &"MSBRM_ARTY_OTW";
         break;
      case "strafing":
         msg = &"MSBRM_STRAFING_OTW";
         break;
      case "bomb":
         msg = &"MSBRM_BOMB_OTW";
         break;
      case "napalm":
         msg = &"MSBRM_NAPALM_OTW";
         break;
      case "phos":
         msg = &"MSBRM_PHOS_OTW";
         break;
      case "smokebarrage":
         msg = &"MSBRM_SMOKE_OTW";
         break;
      default:
         return;
   }
   
   for(i=0; i <level.players.size; i++)
   {
      plr = level.players[i];
      
      if(plr.pers["team"] == self.pers["team"] && 
      //   plr != self && 
         isAlive(plr) && 
         plr.sessionstate == "playing" && 
         (plr hasWeapon("arty_radio_mp") || plr.hasArtyBinoculars == true || plr.hasNcoBinoculars == true))
         
         plr iprintln(msg);
   }
}

endSelectionOn( waitfor )
{
	self endon( "stop_location_selection" );
	
	self waittill( waitfor );

	self thread stopHardpointLocationSelection( (waitfor == "disconnect") );
}

endSelectionOnGameEnd()
{
	self endon( "stop_location_selection" );
	
	level waittill( "game_ended" );
	
	self thread stopHardpointLocationSelection( false );
}

stopHardpointLocationSelection( disconnected )
{
	if ( !disconnected )
	{
		self endLocationSelection();
		self.selectingLocation = undefined;
		self setClientDvars("ui_bombhelptext","");
	}
	self notify( "stop_location_selection" );
}

pausePlace()
{
   self endon( "stop_location_selection" );
   
   self.commandPlaceTicker = 0;
   self thread resetTicker();
   while(self.commandPlaceTicker < 2)
   {
      self.commandPlaceTicker++;
      
      wait 0.05;
   }
   self notify("can_click_again");
}

resetTicker()
{
   self endon( "stop_location_selection" );
   self endon("can_click_again");
   
   for(;;)
   {
      self waittill( "confirm_location", location );
      self.commandPlaceTicker = 0;  
   }
}

