#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

rearm_handler() // this code is generally shite - but seemed good at the time :-/ Extraloadout rearming worked much better
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	self endon("death_or_disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	level.rearmDist = 60;
	
	players = get_players();
   
   if(players.size < 2) // Only one player in map - exit
   {
      self iprintln("No Players");
      return;
   }
   
   minDist = 1000;
   closest = self;
   for (i = 0; i < players.size; i++)
   {
      if((players[i] != self) && (self.pers["team"] == players[i].pers["team"]) && (players[i].sessionstate == "playing") && players[i].isBeingRearmed == false && players[i].isRearming == false)
      {
         dist = distance(self.origin, players[i].origin);
         if(dist < minDist) { minDist = dist; closest = players[i]; }
      }
   }
	
	if(minDist < level.rearmDist)
	{
      //self iprintln("^3Rearming " + closest.name);
      self thread rearmPlayer(closest);
	}
}

rearmPlayer(target)
{
   // Freeze self while holding 'use'
   // Freeze target for at least 1 second to stop them running away again ->> haltRearmTarget function
   // After 1 second target can leave and the rearm is cancelled if they are more than level.rearmDist away.
   
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	self endon("death_or_disconnect");
	level endon("intermission");
	level endon("game_ended");
		
	self SetMoveSpeedScale(0);
	self AllowJump(false);
	self thread haltRearmTarget(target, 1);
	
	targetname = target.name;
	self.isRearming = true;
	target.isBeingRearmed = true;
	elapsed = 0;
	numClips = 0;
	totalClips = 0;
	rearmInfo = [];
   totalTime = 0;
   timeStpIdx = 0;
   timeStp = [];
   
   if(getDvar("bro_rearmPistols")=="1") rearmPistols = true;
   else rearmPistols = false;
   
   targetWeapons = target maps\mp\gametypes\_weapons::getPlayerWeapons(rearmPistols, false);

   tempAmmoReserve = self.RearmAmmoStock;
   for(i=0; i < targetWeapons.size; i++)
   {
      if(!maps\mp\gametypes\_magazines::notSpecial(targetWeapons[i]))
         continue;
         
      if(isdefined(target.hasJam[targetWeapons[i]]) && target.hasJam[targetWeapons[i]]) 
      {
         curAmmo = target.jamAmmo[targetWeapons[i]];
      }
      else
      {
         curAmmo = target GetWeaponAmmoStock(targetWeapons[i]);
      }
      maxAmmo = WeaponMaxAmmo(targetWeapons[i]);
      clipSize = WeaponClipSize(targetWeapons[i]);

      numClips = int(floor((maxAmmo - curAmmo) / clipSize));
      totalClips += numClips;
     // iprintln( numClips + " clips for " + targetWeapons[i] + " (" + clipSize + " rounds)");
      
      clipTime = rearmClipReloadTime(clipSize);
      
      for(y=0; y < numClips; y++)
      {
         if(tempAmmoReserve < clipSize) 
         {
           // iprintln("Insufficient Ammo Reserve ");
            continue;
         }
         else
         {
            tempAmmoReserve -= clipSize;
          //  iprintln("elsing - creating clip data");
            totalTime += clipTime;
            timeStp[timeStpIdx] = totalTime;
            rearmInfo[timeStpIdx]["weapon"] = targetWeapons[i];
            rearmInfo[timeStpIdx]["amount"] = clipSize;
            timeStpIdx++;
         }
      }
   }
   
  // iprintln("stepArrSize = " + timeStp.size + ". total time = " + totalTime);
   
	//rearmTime = 8;
	if(totalTime > 0)
      rearmTime = (totalTime / 20);
   else
      rearmTime = 0.05;
	
      self rearmHUD(target, rearmTime, false, "none"); // creates hud icons
	
	
	self thread rearmAmmoSound(self);
	target thread rearmAmmoSound(self);
	timeStpIdx = 0;
   while(self useButtonPressed() && distance(self.origin, target.origin) < level.rearmDist && target.sessionstate == "playing" && elapsed < totalTime)   
   {
      if(elapsed + 1 == timeStp[timeStpIdx])
      {
         //iprintln("Rearming");
        // iprintln("Giving " + rearmInfo[timeStpIdx]["amount"] + " of " + rearmInfo[timeStpIdx]["weapon"] + " ammo");
         if(isdefined(target.hasJam[rearmInfo[timeStpIdx]["weapon"]]) && target.hasJam[rearmInfo[timeStpIdx]["weapon"]]) 
         {
            target.jamAmmo[rearmInfo[timeStpIdx]["weapon"]] += rearmInfo[timeStpIdx]["amount"];
         }
         else
         {
            curAmmo = target GetWeaponAmmoStock(rearmInfo[timeStpIdx]["weapon"]);   
            target SetWeaponAmmostock(rearmInfo[timeStpIdx]["weapon"], (curAmmo + rearmInfo[timeStpIdx]["amount"])); 
         }
         self.RearmAmmoStock -= rearmInfo[timeStpIdx]["amount"];
         newWidth = int(((self.RearmAmmoStock / level.maxRearmAmmo) * self.rearmBarwidth));
         if(isdefined(self.rearmAmmoProgress)) self.rearmAmmoProgress setShader("white",  newWidth, 2);
         timeStpIdx++;
      }
      self disableWeapons();
      //if(randomInt(20)==1) { self playLocalSound("ammo_pickup_plr"); target playLocalSound("ammo_pickup_plr"); }
      self SetMoveSpeedScale(0);
      self AllowJump(false);
     // self iprintln("Rearming " + target.name);
      wait(0.05);
      elapsed++;
   }
   
   if(target.sessionstate != "playing") { self iprintln(targetname + " has died"); self rearmHUD(self, rearmTime, "self"); }
   else 
   {  
      if(totalTime == 0 && totalClips > 0) self iprintln(&"MSBRM_OUT_OF_REARM_AMMO");
      else if(totalTime == 0) self iprintln(targetname + " cannot carry any more ammo");
      else self iprintln("Finished Rearming");
   
      self rearmHUD(target, rearmTime, true, "all");
   }
   
   self enableWeapons();
   self AllowJump(true);
   self.isRearming = false;
   target.isBeingRearmed = false;
   self SetMoveSpeedScale(self.moveSpeedDefault);
}

rearmHUD(target, rearmTime, cleanup, cleanupPeople)
{
   if(cleanup == true)
   {
      self cleanRearmProgress();
      if(cleanupPeople == "all") target cleanRearmProgress();
   }
   else
   {
      self thread createRearmProgress(rearmTime, target, false);
      target thread createRearmProgress(rearmTime, self, true);
   }
}

createRearmProgress(rearmTime, name, isTarget)
{
   if(!isdefined(self.rearmBarBack))
   {
      self.rearmBarBack = newClientHudElem(self);
      self.rearmBarBack.x = -50; //0;
      self.rearmBarBack.y = -80; //104;
		self.rearmBarBack.alignX = "center";
		self.rearmBarBack.alignY = "middle";
      self.rearmBarBack.horzAlign = "right";
		self.rearmBarBack.vertAlign = "bottom";
   }
   
   self.rearmBarBack.alpha = 0.5;
   self.rearmBarBack setShader("black", 70, 2);
   
   if(!isdefined(self.rearmBarProgress))
	{
      self.rearmBarProgress = newClientHudElem(self);    
      self.rearmBarProgress.x = -85;
		self.rearmBarProgress.y = -80;
		self.rearmBarProgress.color = (1,0,0);
      self.rearmBarProgress.alignX = "left";
      self.rearmBarProgress.alignY = "middle";
      self.rearmBarProgress.horzAlign = "right";
      self.rearmBarProgress.vertAlign = "bottom";
	}
			            
	self.rearmBarProgress setShader("white", 0, 2);
	self.rearmBarProgress scaleOverTime(rearmTime, 70, 2);
	
	self.rearmIcon = createIcon( "specialty_extraammo", 25, 25 );
	self.rearmIcon setPoint( "CENTER", "RIGHT", -55, 135 );

   if(!isdefined(self.rearmLabel))
	{
      self.rearmLabel = newClientHudElem(self);
		self.rearmLabel.x = -50;
		self.rearmLabel.y = -89;
		self.rearmLabel.alignX = "center";
      self.rearmLabel.alignY = "middle";
		self.rearmLabel.horzAlign = "right";
		self.rearmLabel.vertAlign = "bottom";
		self.rearmLabel.archived = false;
		self.rearmLabel.font = "default";
		self.rearmLabel.fontscale = 1;
   }
   
   if(isTarget == true)
      self.rearmLabel.label = (&"Being Rearmed By");
   else
   {
      self.rearmLabel.label = (&"Rearming");
      
      if(!isdefined(self.rearmAmmoBack))
      {
         self.rearmAmmoBack = newClientHudElem(self);
         self.rearmAmmoBack.x = -15; //0;
         self.rearmAmmoBack.y = -77; //104;
         self.rearmAmmoBack.alignX = "right";
         self.rearmAmmoBack.alignY = "bottom";
         self.rearmAmmoBack.horzAlign = "right";
         self.rearmAmmoBack.vertAlign = "bottom";
      }
   
      self.rearmAmmoBack.alpha = 0.5;
      self.rearmAmmoBack setShader("black", self.rearmBarwidth, 2);
   
      if(!isdefined(self.rearmAmmoProgress))
      {
         self.rearmAmmoProgress = newClientHudElem(self);    
         self.rearmAmmoProgress.x = -15; // -15
         self.rearmAmmoProgress.y = -77; // -100
         self.rearmAmmoProgress.color = (0,0,0.52); // (0.15, 0.5, 0.13);//(0,1,0);
         self.rearmAmmoProgress.alignX = "right";
         self.rearmAmmoProgress.alignY = "bottom";
         self.rearmAmmoProgress.horzAlign = "right";
         self.rearmAmmoProgress.vertAlign = "bottom";
      }
      //self.rearmAmmoProgress setShader("white", self.rearmBarwidth, 2);   
   }
   
   if(!isdefined(self.rearmName))
	{
      self.rearmName = newClientHudElem(self);
		self.rearmName.x = -50;
		self.rearmName.y = -71;
		self.rearmName.alignX = "center";
      self.rearmName.alignY = "middle";
		self.rearmName.horzAlign = "right";
		self.rearmName.vertAlign = "bottom";
		self.rearmName.archived = false;
		self.rearmName.font = "default";
		self.rearmName.fontscale = 1;
   }
   self.rearmName setPlayerNameString(name); 
}

cleanRearmProgress()
{
   if(isdefined(self.rearmBarBack))
      self.rearmBarBack destroy(); 
      
   if(isdefined(self.rearmBarProgress))	
      self.rearmBarProgress destroy();	
	     
   if(isdefined(self.rearmIcon))
      self.rearmIcon destroy();
		
   if(isdefined(self.rearmLabel))
		self.rearmLabel destroy();
      
   if(isdefined(self.rearmName))	
		self.rearmName destroy();
		
   if(isdefined(self.rearmAmmoBack))	
		self.rearmAmmoBack destroy();
	
	if(isdefined(self.rearmAmmoProgress))	
		self.rearmAmmoProgress destroy();
}

rearmHudInit()
{
   self.RearmAmmoStock = level.maxRearmAmmo;
   self.rearmBarwidth = 70;
   
   self iprintln("^5You have " + self.RearmAmmoStock + " rounds to rearm.");
}

rearmAmmoSound(giver)
{
 //  self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	self endon("death_or_disconnect");
	level endon("intermission");
	level endon("game_ended");
	
   while(giver.isRearming)
   {
      if(randomInt(10)==1)
      {
         self playLocalSound("ammo_pickup_plr");
         wait 0.3;
      }
      wait 0.05;
   }
}

rearmClipReloadTime(clipsize)
{
  // in 20ths of a second
  if(clipsize < 11) return 20;
  else if(clipsize < 33) return 30;
  else return 40;
}

haltRearmTarget(target, time)
{
   //self endon("killed_player");
	//self endon("spawned");
	//self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
//	target endon("killed_player");
	target endon("spawned");
//	target endon("disconnect");
	target endon("death_or_disconnect");
	
   if(time <= 0) return;
   
   time *= 10;
   elapsed = 0;
   rearmer = self.name;
   target SetMoveSpeedScale(0);
   target AllowJump(false);
   
   while(self.isRearming == true && elapsed < time && self.sessionstate == "playing")
   {
      target SetMoveSpeedScale(0);
      target AllowJump(false);
      wait 0.1;
      elapsed++;
   }
   if(self.sessionstate != "playing") target iprintln(rearmer + " has died.");
   target SetMoveSpeedScale(target.moveSpeedDefault);
   target AllowJump(true);
}


watchSupportHandler(class)
{
 //  self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
	self endon("death_or_disconnect");
	level endon("intermission");
	level endon("game_ended");
	
   while(1)
   {
      
      if(self.helpPointTargetDistance < 4900)
      {
         targ = self.helpPointTarget;
         
         if(class == "support")
            weapon = targ hasSupportWeapon();
         else
            weapon = targ hasAntitankWeapon();
         
         recharges = self GetWeaponAmmoClip(class + "_ammo_mp");
           
         if(weapon == "none" || recharges <= 0)
         {
            if(!((isdefined(self.isDefusing) && self.isDefusing == true) || (isDefined(self.isPlanting) && self.isPlanting == true)) && !isdefined(self.standingNrBox))
            {
               if(recharges <= 0)
               {
                  if(!isdefined(self.useBarText))
                     self.useBarText = createPrimaryProgressBarText();
                     
                  self.useBarText showElem();
                  self.useBarText setText( &"BRM2_OUT_OF_AMMO" );
               }
               else if(isdefined(self.useBarText))
                  self.useBarText hideElem();
            
               if(isdefined(self.useBar))
                  self.useBar hideElem();     
            }
            wait 0.2;
            continue;
         }
         if(weapon == "mortar_mp")
         {
            self handleMortar(targ,recharges);
         }
         else
         {   
            clipsize = WeaponClipSize(weapon);
            maxammo = WeaponMaxAmmo(weapon);
            
            if(isdefined(targ.hasJam[weapon]) && targ.hasJam[weapon]) 
               stock = targ.jamAmmo[weapon];
            else
               stock = targ GetWeaponAmmoStock(weapon);
                       
            numClips = int(floor((maxAmmo - stock) / clipSize));
            
            if(numClips > recharges)
               numClips = recharges;
                        
            if(!isdefined(self.useBarText))
               self.useBarText = createPrimaryProgressBarText();
               
            if(!isdefined(self.useBar))
               self.useBar = createPrimaryProgressBar();
               
            self.useBarText showElem(); 
            self.useBar hideElem();
            
            if(numClips <= 0)
            {
               self.useBarText setText( &"BRM_CANT_HOLD_MORE_SUPPORT" );
            }
            else
            {
               self.useBarText setText( &"BRM_HOLD_TO_REARM" );
          
               if(self useButtonPressed())
               {
                  self SetMoveSpeedScale(0);
                  self AllowJump(false);
                  self disableWeapons();
                  targ.rearmer = self;

                  self.useBarText setText( &"BRM_BANDAGING" );

                  self.useBarText setText( &"BRM_REARMING" );
                  
                  time = numClips * game["extra_rearmtime"];
                           
                  self.useBar showElem();
                  self.useBar updateBar( 0, (1/time));
                               
                  self thread watchForRearmingDeath(targ);
                  targ iprintln("^3Being rearmed by ^7" + self.name);
                  
                  timediv = game["extra_rearmtime"] / 20;
                  
                  while(self useButtonPressed() && time > 0 && isAlive(targ))
                  {     
                     self.useBarText setText( &"BRM_REARMING" );  
                                  
                     wait game["extra_rearmtime"];
                     
               //      wait 0.05;
               
                     if(!self useButtonPressed())
                        break;
                     
                     self SetMoveSpeedScale(0);               
                     self AllowJump(false);
                     self disableWeapons();
                     targ SetMoveSpeedScale(0);
                     targ AllowJump(false);
                     
                        self playLocalSound("ammo_pickup_plr");
                        targ playLocalSound("ammo_pickup_plr");
                                       
                        if(targ.weaponState[weapon]!="fullclip" && targ.weaponState[weapon]!="single")
                        {
                           targ maps\mp\gametypes\_magazines::modifyClips(1, weapon, clipsize, true);
                                         
                           targ.curStock[weapon] = clipsize * (targ.numFullClips[weapon] - 1);
                       
                           if(!isdefined(targ.hasJam[weapon]) || targ.hasJam[weapon] == false)            
                              targ SetWeaponAmmoStock(weapon, targ.curStock[weapon] );
                        }
                        else
                        {
                           if(isdefined(targ.hasJam[weapon]) && targ.hasJam[weapon] == true) 
                           {
                              targ.jamAmmo[weapon] += clipsize;
                           }
                           else
                           { 
                              curAmmo = targ GetWeaponAmmoStock(weapon);   
                              targ SetWeaponAmmostock(weapon, (curAmmo + clipsize)); 
                           }
                        }
                        
                        self setWeaponAmmoClip( class + "_ammo_mp", (self GetWeaponAmmoClip(class + "_ammo_mp") - 1) ); 
                     
                     time -= game["extra_rearmtime"];
                  //   time -= timediv;
                  }
                  
                  targ SetMoveSpeedScale(targ.moveSpeedDefault);
                  targ AllowJump(true);
                  
                  while(self useButtonPressed() && isAlive(targ))
                  {
                     self.useBarText setText( &"BRM_DONE" );
                     wait 0.1;
                  }
                  self SetMoveSpeedScale(self.moveSpeedDefault);
                  self AllowJump(true);
                  self enableWeapons();   
                              
                  targ.rearmer = undefined;    
               }    
            } 
         }         
      }
      else
      {
         if(!((isdefined(self.isDefusing) && self.isDefusing == true) || (isDefined(self.isPlanting) && self.isPlanting == true)) && !isdefined(self.standingNrBox))
         {
            if(isdefined(self.useBarText) && !isDefined(self.canReloadMG))
               self.useBarText hideElem();
         
            if(isdefined(self.useBar))
               self.useBar hideElem();     
         }
      } 
      wait 0.2;
   }
}

handleMortar(targ,recharges)
{

   numClips = recharges;
               
   if(!isdefined(self.useBarText))
      self.useBarText = createPrimaryProgressBarText();
      
   if(!isdefined(self.useBar))
      self.useBar = createPrimaryProgressBar();
      
   self.useBarText showElem(); 
   self.useBar hideElem();
   
 //  if(numClips <= 0 || !isDefined(self.mortarShells))
   if(numClips <= 0)
   {
      self.useBarText setText( &"BRM_CANT_HOLD_MORE_SUPPORT" );
   }
   else
   {
      self.useBarText setText( &"BRM_HOLD_TO_REARM" );
 
      if(self useButtonPressed())
      {
         self SetMoveSpeedScale(0);
         self AllowJump(false);
         self disableWeapons();
         targ.rearmer = self;

         self.useBarText setText( &"BRM_BANDAGING" );

         self.useBarText setText( &"BRM_REARMING" );
         
         time = numClips * game["extra_rearmtime"];
                  
         self.useBar showElem();
         self.useBar updateBar( 0, (1/time));
                      
         self thread watchForRearmingDeath(targ);
         targ iprintln("^3Being rearmed by ^7" + self.name);
         
         timediv = game["extra_rearmtime"] / 20;
         
         while(self useButtonPressed() && time > 0 && isAlive(targ) && (isDefined(targ.mortar) || targ hasweapon("mortar_mp")))
         {     
            self.useBarText setText( &"BRM_REARMING" );  
                         
            wait game["extra_rearmtime"];
            
      //      wait 0.05;
      
            if(!self useButtonPressed())
               break;
            
            self SetMoveSpeedScale(0);               
            self AllowJump(false);
            self disableWeapons();
            targ SetMoveSpeedScale(0);
            targ AllowJump(false);
            
            self playLocalSound("ammo_pickup_plr");
            targ playLocalSound("ammo_pickup_plr");
            
            if(isDefined(targ.mortar))
            {
               targ.mortar.shells += 3;
               targ maps\mp\gametypes\_mortars::createMortarHUD();
            }
            else if(isDefined(targ.mortarShells))
               targ.mortarShells += 3;
                     
            time -= game["extra_rearmtime"];
         //   time -= timediv;
         
            self setWeaponAmmoClip( "at_ammo_mp", (self GetWeaponAmmoClip("at_ammo_mp") - 1) ); 
         }
         
         targ SetMoveSpeedScale(targ.moveSpeedDefault);
         targ AllowJump(true);
         
         while(self useButtonPressed() && isAlive(targ))
         {
            self.useBarText setText( &"BRM_DONE" );
            wait 0.1;
         }
         self SetMoveSpeedScale(self.moveSpeedDefault);
         self AllowJump(true);
         self enableWeapons();   
                     
         targ.rearmer = undefined;    
      }    
   }
}

watchForRearmingDeath(target)
{
   self endon("spawned");
   
   while(isAlive(self) && self.isBandaging)
      wait 0.1;
   
   if(isdefined(target))
   {   
      target SetMoveSpeedScale(target.moveSpeedDefault);
      target AllowJump(true);
   }
}

hasSupportWeapon()
{
   for(i=0; i<game["weapons"]["support"].size; i++)
   {
      if(self hasWeapon(game["weapons"]["support"][i]))
         return game["weapons"]["support"][i];
   }   
   return "none";
}

hasAntitankWeapon()
{
   if(isDefined(self.mortar))
      return "mortar_mp";
      
   for(i=0; i<game["weapons"]["antitank"].size; i++)
   {
     // iprintln("Checking " + game["weapons"]["antitank"][i]);
      if(self hasWeapon(game["weapons"]["antitank"][i]))
      {
         return game["weapons"]["antitank"][i];
      }
   }
   return "none";
}
