#include maps\mp\gametypes\_airsupport;
#include maps\mp\_utility;

doStrafe(team, initialAngle,owner)
{
   dvarAng = getdvarint("plane_debug_angle");
   
   if(initialAngle != 999)
   {
      strafeAngle = initialAngle;
   }
   else
   {
      level.airPlanes[team][0].passes = 0;
      level.airPlanes[team][0].crashed = false;
      
      if(dvarAng == 999)
         strafeAngle = randomint(360);
      else
         strafeAngle = dvarAng;
   }
   
	flyPastStrafe(team, strafeAngle,owner);
 
   if(isdefined(level.airPlanes[team][0].targetLoc))
      level thread startStrafe(team, (strafeAngle + 130), owner);
      
   game["airsupport"][team]["cooldown"] = level.airsupportCooldown;
}

flyPastStrafe(team, strafeAngle,owner)
{
   flightLength = 11500;
   
   cosVal = cos(strafeAngle);
   sinVal = sin(strafeAngle);
   
   if(cosVal < 0.001 && cosVal > -0.001)
   {
      yVar = 0;
      xVar = flightLength;
   }
   else
   {
      yVar = flightLength * cosVal;
      xVar = flightLength * (sinVal);
   }
   midpoint = level.mapMidPoint + (randomint(1400),randomint(1400),0);
   
   strafeStart = midpoint - (xVar, yVar, 0); 
   strafeEnd = midpoint + (xVar, yVar, 0); 
   
   level.airPlanes[team][0] hide();
   wait 0.05;  
   level.airPlanes[team][0] moveto(strafeStart, 0.05);
   level.airPlanes[team][0].angles = (0,(90-strafeAngle),0);
     
   level.airPlanes[team][0] waittill("movedone");
   
   level.airPlanes[team][0] thread play_loop_sound_on_entity( "ambient_corsair" );
   wait 2;
      
   level.airPlanes[team][0] show();
   level.airPlanes[team][0] moveto(strafeEnd,8.5);
   
   level.airPlanes[team][0] thread randFlyRotate(8);
   
   level thread updateTargetLoc(team,owner);
   
   game["airsupport"][team]["cooldown"] = level.airsupportCooldown;  
    
   level.airPlanes[team][0] waittill("movedone");
   
   level.airPlanes[team][0] notify ( "stop sound" + "ambient_corsair" );
  
   level.airPlanes[team][0] hide();
   
   level.airPlanes[team][0].passes++;
   
   if(level.airPlanes[team][0].passes > level.strafeMaxPasses)
      return;
   
   wait 0.5;
   
   if(!isdefined(level.airPlanes[team][0].targetLoc))
   {
      
  //    iprintln("^2Found Point: " + level.airPlanes[team].targetLoc);
      level.airPlanes[team][0].targetLoc = undefined;
      if(level.strafeDebug)
         iprintln("^3Trying another flypast - no players spotted");
      level thread doStrafe(team, (strafeAngle + 150 + randomint(60)),owner );
      
      return;
   }
}

randFlyRotate(time)
{
   timer = 0;
   time /= 2;
   
   self rotateroll(5,0.5);
   self waittill("rotatedone");
   
   while(timer < time)
   {
      self rotateroll(-10,1);
      self waittill("rotatedone");
      self rotateroll(10,1);
      self waittill("rotatedone");
      timer++;
   } 

}

startStrafe(team, initialAngle, owner)
{
   strafeLength = 200;
   
   dvarAng = getdvarint("plane_debug_angle");
   
   if(dvarAng == 999)
      strafeAngle = initialAngle + randomint(100);
   else
      strafeAngle = dvarAng;
      
   attempts = 0;
 //  iprintln("running strafe");
   
   
   if(!isdefined(level.airPlanes[team][0].targetLoc))
   {
      if(level.strafeDebug)
         iprintln("^3Trying another flypast");
      level thread doStrafe(team, (initialAngle + 30 + randomint(40)),owner );
         
      return;
   
   }
     
   point = level.airPlanes[team][0].targetLoc;
   
   while(1)
   {
    //  point = targ.origin;
         
      level.strafeMinHeight = getdvarint("bro_strafeheightoffset_" + toLower(getDvar("mapname")));
      
      wait 0.05;
      cosVal = cos(strafeAngle);
      sinVal = sin(strafeAngle);

      if(cosVal < 0.001 && cosVal > -0.001)
      {
         yVar = 0;
         xVar = strafeLength;
      }
      else
      {
         yVar = strafeLength * cosVal;
         xVar = strafeLength * (sinVal);
      }
   
      level.strafeStart = point - (xVar, yVar, 0); 
      level.strafeEnd = point + (xVar, yVar, 0); 
      level.strafeSpawn = point - ((xVar * 40), (yVar * 40), -2000); //(-2500, 0, 0);
      
  //    if(!isdefined(point))
  //    return;
   
      target = level.strafeEnd + (0,0,level.strafeMinHeight);
   
      xDist = level.strafeEnd[0] - level.strafeSpawn[0]; 
   
      xSpacing = xDist / 20;
   
      yDist = level.strafeEnd[1] - level.strafeSpawn[1]; 
   
      ySpacing = yDist / 20;
   
      VertDist = level.strafeSpawn[2] - target[2];
  
      vertSpacing = vertDist / 20;
     
      planeTargPoint = ( ( level.strafeSpawn[0] + (20 * xSpacing)), (level.strafeSpawn[1] + (20 * ySpacing)), (level.strafeSpawn[2] - (20 * vertSpacing)));
   
      skyboxEntry = bulletTrace( planeTargPoint + (0,0,level.mapMaxHeight - planeTargPoint[2] - 50), level.strafeSpawn, true, self );
  
      z = planeTargPoint[2] + ((distance2d(planeTargPoint,skyboxEntry["position"]) * 2000) / (distance2D(planeTargPoint,level.strafeSpawn)));

      entryPos = (skyboxEntry["position"][0],skyboxEntry["position"][1],skyboxEntry["position"][2] - z); // THIS LINE - z component
    
      entryTrace = bulletTrace( entryPos, planeTargPoint , true, self );
    
      if(entryTrace["fraction"] == 1) break;
                  
      trace = bulletTrace( point + (0,0,level.mapMaxHeight), point - (0,0,30), true, self );
               
      point = trace["position"];
      
      strafeAngle = initialAngle + randomint(100);
      
      // strafeAngle = randomint(360);
         
      if(strafeAngle == 270) strafeAngle=269;
      
      if(level.strafeDebug)
         iprintln("^1Path Invalid - trying " + strafeAngle);
      
      attempts++;
      
      if(attempts > level.strafePathAttempts)
      {  
         if(level.strafeDebug)
            iprintln("^3Trying another flypast");
         level thread doStrafe(team, (initialAngle + 30 + randomint(40)), owner );
         
         return;
      }
   }
       
   idx = 0;
   points = [];
   
   for(i=0; i < 20; i++)
   {
      points[idx] = ((level.strafeSpawn[0]+ ((i+1) * xSpacing)), (level.strafeSpawn[1] + ((i+1) * ySpacing)), (level.strafeSpawn[2] - ((i+1) * vertSpacing)));
      idx++;
   }
   wait 0.1;
   points[idx] = points[idx-1] + (xSpacing,ySpacing,0);
   idx++;
   
   if(ySpacing == 0) ySpacing = -1; 
   if(xSpacing == 0) xSpacing = 1;
   
   dir = randomint(2);
   if(dir == 0) dir = -1;
   for(i=0; i < 30; i++)  
   {
      points[idx] = ((points[idx-1][0] + (xSpacing + (i * cosVal * 25 * dir))), (points[idx-1][1] + (ySpacing - (i * sinVal * 25 * dir))), (points[idx-1][2] + vertSpacing));
      idx++;
   }
   
   if(level.strafeDebug)
      iprintln("^2Valid Path Found " + dir);
    
   wait 0.1;
   level.airPlanes[team][0].strafePoints = [];
   level.airPlanes[team][0].strafePoints = points;
   
   level.airPlanes[team][0] hide();
    wait 0.05;  
   
   level.airPlanes[team][0] moveto(level.strafeSpawn, 0.05);
   level.airPlanes[team][0].angles = (40,(90-strafeAngle),0);
   level.airPlanes[team][0] waittill("movedone");
   
   level.airPlanes[team][0] thread play_loop_sound_on_entity( "ambient_corsair" );
      
   //level notify("strafe_start");

   wait 2.5;
   
   level thread updateTargetLoc(team,owner);
   
   level.airPlanes[team][0].canFire = true;
           
   level.airPlanes[team][0] thread rotatePlane(dir);
      
   level.airPlanes[team][0] thread runFX(team,owner);

   level.airPlanes[team][0] movePlane();
    
   level.airPlanes[team][0] notify("strafe_finished");
 //  wait 6;    
   level.airPlanes[team][0] notify ( "stop sound" + "ambient_corsair" );
  
   level.airPlanes[team][0] hide();
   
   level.airPlanes[team][0].passes++;
   
   game["airsupport"][team]["cooldown"] = level.airsupportCooldown;
   
   if(level.airPlanes[team][0].passes > level.strafeMaxPasses || level.airPlanes[team][0].crashed)
      return;
        
   wait 4;  
   
   if(dir == 1)
      initialAngle += 220;
   else
      initialAngle += 40;
      
   level thread startStrafe(team, initialAngle, owner); 
}

movePlane()
{
   self endon("strafe_finished");

   self show();
       
   for(i=0; i < self.strafePoints.size; i++)
   {
      self moveto(self.strafePoints[i], 0.2);
      wait 0.15;
   
   } 
   wait 0.2;
}

rotatePlane(dir)
{
   self endon("strafe_finished");
   
   self rotatepitch(-35,2.9);
   self waittill("rotatedone");
 
   self.canFire = false;
 //  level.strafePlane notify("stopsound_weap_50cal_fire");

   self rotateto(self.angles + (-8, (dir * -52), (dir * 70)), 2.8); 
}

runFX(team,owner)
{
   self endon("strafe_finished");
   wait 0.6;
  // if(!level.planeBomb) 
   
  // self thread playloopsoundonentity ("weap_50cal_fire");

   for (;;)
	{   
      if(self.canFire == true)
      {  
         self playsound("weap_50cal_fire");
         
         playfxOnTag(level._effect["mg42"], self, level.gun_markerL[team][0].tagname);
         self testTracer(level.gun_markerL[team][0], team,owner);
       self playsound("weap_50cal_fire");
         playfxOnTag(level._effect["mg42"], self, level.gun_markerR[team][0].tagname);
         self testTracer(level.gun_markerR[team][0], team,owner);
            
      }
      
       trace = bulletTrace( level.gun_markerR[team][0].origin, level.gun_markerL[team][0].origin, false, level.gun_markerR[team][0].origin );

         if(trace["fraction"] < 0.9 && trace["surfacetype"]!="default" && trace["surfacetype"]!="none")
         {  
            if(level.strafeDebug)
               iprintln("Explode!");
            self hide();
            radiusdamage(trace["position"] + (0,0,4), 200, 1000, 1000);
            thread playSoundinSpace( "vehicle_explo", trace["position"], 3 );
            playfx(level._effect["plane_explosion"],trace["position"]);
            earthquake(1.0, 1.5, trace["position"], 1000);
            self.crashed = true;
         //   self notify("stopsound_stuka_guns");
            
            self notify("strafe_finished");
         }

		wait (0.05);
	}
}

testTracer(tag,team,owner)
{
   trace = [];
   endOrigin = [];
   startOrigin = [];
  
   startOrigin = tag.origin  + (randomint(20),randomint(20),0);

   endOrigin = self getTargetPos(10000, startOrigin, tag);

   trace = bulletTrace( startOrigin, endOrigin, true, self );
  // iprintln(trace["surfacetype"]);
   wait 0.05;
   groundEffects( trace["position"], trace["surfacetype"]);
   
   locRadiusDamage(trace["position"] + (0,0,4), level.strafePlaneAccuracy, 300, 40, team, self, startOrigin, "MOD_RIFLE_BULLET", "strafeplane_mp",owner);
//   locRadiusDamage(trace["position"] + (0,0,4), level.strafePlaneAccuracy, 300, 40, team, tag, startOrigin, "MOD_RIFLE_BULLET", "strafeplane_mp",owner);

 //  radiusdamage(trace["position"] + (0,0,4), 70, 1000, 1000);
}

forget(ent)
{
   wait 0.1;
   if(isdefined(ent))
      ent = undefined;
}

getTargetPos(range, startOrigin, tag)
{ 
   angles = tag.angles;
   forward = anglesToForward(angles);
   forward = vector_scale(forward, range);
   endOrigin = startOrigin + forward;
   
   return endOrigin; 
}

groundEffects(pos, surfaceType)
{
   if(surfaceType == "default")
      return;
      
   switch(surfaceType)
   {
      case "dirt":
      case "grass":
         effect = "plane_ground_effect_dirt";
         sound = "bullet_large_dirt";
         break;
      case "rock":
      case "asphalt":
      case "gravel":
      case "concrete":
      case "default":
      case "brick":
         effect = "plane_ground_effect_gravel";
         sound = "bullet_large_gravel";
         break;
      
      case "metal":
         effect = "plane_ground_effect_metal";
         sound = "bullet_large_metal";
         break;
         
      case "wood":
      case "bark":
         effect = "plane_ground_effect_wood";
         sound = "bullet_large_wood";
         break;
         
      case "plaster":
      case "paper":
         effect = "plane_ground_effect_plaster";
         sound = "bullet_large_plaster";
         break;
         
      case "water":
         effect = "plane_ground_effect_water";
         sound = "bullet_large_water";
         break;
      default:
         effect = "plane_ground_effect_dirt";
         sound = "bullet_large_dirt";
         break;   
   }

   playfx(level._effect[effect],pos);
      
   thread playSoundinSpace(sound, pos, 0.1);
}

getOutsidePlayers(team)
{  
   if(team == "allies") sTeam = "axis";
   else sTeam = "allies";
   
   wait 3;
   plrs = [];
   
   for(i=0; i<level.players.size; i++)
   {
      plr = level.players[i];
      
      if(isAlive(plr) && plr.pers["team"] == sTeam)
      {  
         target = plr.origin + (0,0,700);
         
         endpos = PhysicsTrace( plr.origin, target );
         
         if(endpos == target)
            plrs[plrs.size] = plr;
            
         wait 0.05;
      }
   }

   return plrs;
}

getBestGroup(plrs)
{
   // initialise
   grps = [];
   
   // group per player
   groupFound = false;
   for(i=0; i < plrs.size; i++) // n^2 loop 
   {
      grps[i] = [];
      grps[i][0] = i;
      
      for(y=0; y < plrs.size; y++)
      {
         if(y != i && distancesquared(plrs[y],plrs[i]) < level.strafeGroupThreshold)
         {
            grps[i][grps[i].size] = y;
         }
      }
      
      if(grps[i].size > 1)
         groupFound = true;
   }
   
   if(level.strafeDebug)
   {
      for(i=0; i<grps.size; i++)
      {
         str = "#" + i;
         
         for(y=0; y< grps[i].size; y++)
            str += "  " + grps[i][y];
         iprintln(str);
      }
   }
      

   if(!groupFound) // all the players are on their own
   {
      if(level.strafeDebug)
         iprintln("^3No groups");
      return plrs[randomint(plrs.size)];
   }
        
   wait 0.05;
   
   // chain them all up
   count = 0;
   for(i=0; i < grps.size; i++)
   {
      if(level.strafeDebug)
         iprintln("^1Checking group #" + i);
         
      for(y=1; y < grps[i].size; y++)
      {
         if(level.strafeDebug)
            iprintln("   ^3Checking child group #" + grps[i][y]);
        
         for(z=1; z < grps[grps[i][y]].size; z++)
         {   
            found = false;
            for(x=0; x < grps[i].size; x++)
            {
               if(grps[i][x] == grps[grps[i][y]][z])
               {
                  found = true;
                  break;
               }
            }
            if(!found)
            {
               grps[i][grps[i].size] = grps[grps[i][y]][z];
               if(level.strafeDebug)
                  iprintln("       ^2Adding ^7" + grps[grps[i][y]][z] + " ^2to group");
            }
         }
      }
      
      if(grps[i].size >= ceil(plrs.size / 2)) // bail if found biggest group
         break;
   }
   
   wait 0.05;
   
   // find most significant group
   biggest = 0;
   for(i=1; i < grps.size; i++)
   {
      if(grps[i].size > grps[biggest].size)
         biggest = i;
   }
   
   wait 0.05;
    
   if(level.strafeDebug)
   {  
      for(i=0; i<grps.size; i++)
      {
         str = "#" + i;
         
         for(y=0; y< grps[i].size; y++)
            str += "  " + grps[i][y];
         iprintln(str);
      }
   }
   
   // get mean point
   mX = 0;
   mY = 0;
   mZ = 0;
   
   for(i=0; i < grps[biggest].size; i++)
   {
      mX += plrs[grps[biggest][i]][0];
      mY += plrs[grps[biggest][i]][1];
      mZ += plrs[grps[biggest][i]][2];
   }
   
   return (int(mx / grps[biggest].size), int(mY / grps[biggest].size), int(mZ / grps[biggest].size));  
}

updateTargetLoc(team,owner)
{
   
   wait 2.5;
   
 //  level.airPlanes[team][0].targetLoc = owner.origin; // some fool left this line active - yes I'm looking at you Robbo!

   
   if(team == "allies") sTeam = "axis";
   else sTeam = "allies";
   
   plrs = [];
   
   for(i=0; i<level.players.size; i++)
   {
      plr = level.players[i];
      
      if(isAlive(plr) && plr.pers["team"] == sTeam)
      {  
         target = plr.origin + (0,0,700);
         
         endpos = PhysicsTrace( plr.origin, target );
         
         if(endpos == target)
            plrs[plrs.size] = plr.origin;
            
         wait 0.05;
      }
   }
   
   if(plrs.size <= 0)
   {
      level.airPlanes[team][0].targetLoc = undefined;
      return;
   }
   
   level.airPlanes[team][0] waittill("movedone");
   
   level.airPlanes[team][0].targetLoc = getBestGroup(plrs);

   
}
