#include maps\mp\_utility;

weaponLimiter_init()
{
   // allowed weapon defaults
	
	wait 0.5;
	
	if(getDvarint("bro_limitWeapons") == 0 || level.squadSystem["active"] > 0) 
      return;
	
	// Bolts
	allowedWeapName[0] = "allow_arisaka"; allowedWeapVal[0] = getDvarint("bro_allow_arisaka"); allowedWeapTeam[0] = "japanese"; allowedWeapNameFull[0] = "type99rifle_mp"; 
	allowedWeapName[1] = "allow_kar98k"; allowedWeapVal[1] = getDvarint("bro_allow_kar98k"); allowedWeapTeam[1] = "german"; allowedWeapNameFull[1] = "kar98k_mp"; 
	allowedWeapName[2] = "allow_nagant"; allowedWeapVal[2] = getDvarint("bro_allow_nagant"); allowedWeapTeam[2] = "russian"; allowedWeapNameFull[2] = "mosinrifle_mp";
	allowedWeapName[3] = "allow_springfield"; allowedWeapVal[3] = getDvarint("bro_allow_springfield"); allowedWeapTeam[3] = "marines"; allowedWeapNameFull[3] = "springfield_mp";
		
	// Semi Autos
	allowedWeapName[4] = "allow_gewehr43"; allowedWeapVal[4] = getDvarint("bro_allow_gewehr43"); allowedWeapTeam[4] = "german"; allowedWeapNameFull[4] = "gewehr43_mp";
	allowedWeapName[5] = "allow_m1carbine"; allowedWeapVal[5] = getDvarint("bro_allow_m1carbine"); allowedWeapTeam[5] = "marines"; allowedWeapNameFull[5] = "m1carbine_mp"; 
	allowedWeapName[6] = "allow_svt40"; allowedWeapVal[6] = getDvarint("bro_allow_svt40"); allowedWeapTeam[6] = "russian"; allowedWeapNameFull[6] = "svt40_mp";
	allowedWeapName[7] = "allow_m1garand"; allowedWeapVal[7] = getDvarint("bro_allow_m1garand"); allowedWeapTeam[7] = "marines"; allowedWeapNameFull[7] = "m1garand_mp"; 
	 
	// SMGs
	allowedWeapName[8] = "allow_mp40"; allowedWeapVal[8] = getDvarint("bro_allow_mp40"); allowedWeapTeam[8] = "german"; allowedWeapNameFull[8] = "mp40_mp"; 
	allowedWeapName[9] = "allow_ppsh_drum"; allowedWeapVal[9] = getDvarint("bro_allow_ppsh_drum"); allowedWeapTeam[9] = "russian"; allowedWeapNameFull[9] = "ppsh_bigammo_mp"; 
	allowedWeapName[10] = "allow_ppsh_stick"; allowedWeapVal[10] = getDvarint("bro_allow_ppsh_stick"); allowedWeapTeam[10] = "russian"; allowedWeapNameFull[10] = "ppsh_mp"; 
	allowedWeapName[11] = "allow_stg44"; allowedWeapVal[11] = getDvarint("bro_allow_stg44"); allowedWeapTeam[11] = "german"; allowedWeapNameFull[11] = "stg44_mp"; 
	allowedWeapName[12] = "allow_thompson"; allowedWeapVal[12] = getDvarint("bro_allow_thompson"); allowedWeapTeam[12] = "marines"; allowedWeapNameFull[12] = "thompson_mp";
	allowedWeapName[13] = "allow_type100"; allowedWeapVal[13] = getDvarint("bro_allow_type100"); allowedWeapTeam[13] = "japanese"; allowedWeapNameFull[13] = "type100smg_mp"; 
	
	// LMG 
	allowedWeapName[14] = "allow_bar"; allowedWeapVal[14] = getDvarint("bro_allow_bar"); allowedWeapTeam[14] = "marines"; allowedWeapNameFull[14] = "bar_bipod_mp"; 
   allowedWeapName[15] = "allow_fg42"; allowedWeapVal[15] = getDvarint("bro_allow_fg42"); allowedWeapTeam[15] = "german"; allowedWeapNameFull[15] = "fg42_mp"; 
   allowedWeapName[16] = "allow_type99"; allowedWeapVal[16] = getDvarint("bro_allow_type99"); allowedWeapTeam[16] = "japanese"; allowedWeapNameFull[16] = "type99lmg_bipod_mp"; 
   
	// HMG
	allowedWeapName[17] = "allow_30cal"; allowedWeapVal[17] = getDvarint("bro_allow_30cal"); allowedWeapTeam[17] = "marines"; allowedWeapNameFull[17] = "30cal_bipod_mp";
	allowedWeapName[18] = "allow_dp28"; allowedWeapVal[18] = getDvarint("bro_allow_dp28"); allowedWeapTeam[18] = "russian"; allowedWeapNameFull[18] = "dp28_bipod_mp";
	allowedWeapName[19] = "allow_mg42"; allowedWeapVal[19] = getDvarint("bro_allow_mg42"); allowedWeapTeam[19] = "german"; allowedWeapNameFull[19] = "mg42_bipod_mp";
	
	// Scopes
	allowedWeapName[20] = "allow_arisaka_scoped"; allowedWeapVal[20] = getDvarint("bro_allow_arisaka_scoped"); allowedWeapTeam[20] = "japanese"; allowedWeapNameFull[20] = "type99rifle_scoped_mp";
 	allowedWeapName[21] = "allow_kar98k_scoped"; allowedWeapVal[21] = getDvarint("bro_allow_kar98k_scoped"); allowedWeapTeam[21] = "german"; allowedWeapNameFull[21] = "kar98k_scoped_mp";
	allowedWeapName[22] = "allow_nagant_scoped"; allowedWeapVal[22] = getDvarint("bro_allow_nagant_scoped"); allowedWeapTeam[22] = "russian"; allowedWeapNameFull[22] = "mosinrifle_scoped_mp";
	allowedWeapName[23] = "allow_springfield_scoped"; allowedWeapVal[23] = getDvarint("bro_allow_springfield_scoped"); allowedWeapTeam[23] = "marines"; allowedWeapNameFull[23] = "springfield_scoped_mp"; 
  
   // Shotguns
   allowedWeapName[24] = "allow_trenchgun_marines"; allowedWeapVal[24] = getDvarint("bro_allow_trenchgun_marines"); allowedWeapTeam[24] = "marines"; allowedWeapNameFull[24] = "shotgun_mp_marines";
   allowedWeapName[25] = "allow_trenchgun_german"; allowedWeapVal[25] = getDvarint("bro_allow_trenchgun_german"); allowedWeapTeam[25] = "german"; allowedWeapNameFull[25] = "shotgun_mp_german";
   allowedWeapName[26] = "allow_trenchgun_japanese"; allowedWeapVal[26] = getDvarint("bro_allow_trenchgun_japanese"); allowedWeapTeam[26] = "japanese"; allowedWeapNameFull[26] = "shotgun_mp_japanese";
   allowedWeapName[27] = "allow_trenchgun_russian"; allowedWeapVal[27] = getDvarint("bro_allow_trenchgun_russian"); allowedWeapTeam[27] = "russian"; allowedWeapNameFull[27] = "shotgun_mp_russian";

   allowedWeapName[28] = "allow_greasegun"; allowedWeapVal[28] = getDvarint("bro_allow_greasegun"); allowedWeapTeam[28] = "marines"; allowedWeapNameFull[28] = "m3a1_mp"; 
	
   // fg42 / stg44 merge special
   
   if(level.fg42stg44Merge > 0)
   {
      allowedWeapVal[11] = level.fg42stg44Merge;
      allowedWeapVal[15] = level.fg42stg44Merge;
   }
   
   if(level.thompsonGreasegunMerge > 0)
   {
      allowedWeapVal[12] = level.thompsonGreasegunMerge;
      allowedWeapVal[28] = level.thompsonGreasegunMerge;
   }
   
   y=0;
   z=0;
   //if(getDvarint("bro_DebugWeapLimit")==1) wait 20;
   
   for(i=0; i < allowedWeapName.size; i++)
   {     
      if((allowedWeapTeam[i]==game["allies"])||(allowedWeapTeam[i]==game["axis"])||(allowedWeapTeam[i]=="all"))
      {
      //   if(getDvarint("bro_DebugWeapLimit")==1) iprintln("^5Weapon: " + allowedWeapNameFull[i] + " Team: " + allowedWeapTeam[i]);
         level.allowedWeapName[y] = allowedWeapName[i]; 
         level.allowedWeapVal[y] = allowedWeapVal[i]; 
         level.allowedWeapNameFull[y] = allowedWeapNameFull[i];
         level.allowedWeapTeam[y] = allowedWeapTeam[i];
        // level.allowedWeapKey[allowedWeapNameFull[i]] = y;
       
         if(allowedWeapVal[i]>0) level.allowWeapon[allowedWeapName[i]] = 1;
         else level.allowWeapon[allowedWeapName[i]] = 0;
         
         level.weaponSetTeam[allowedWeapNameFull[i]] = allowedWeapTeam[i];
         level.weaponSetLimit[allowedWeapNameFull[i]] = allowedWeapVal[i];
         level.weaponDvarName[allowedWeapNameFull[i]] = allowedWeapName[i];
         print("setting up " + level.allowedWeapNameFull[y] + " limits\n");
         
         y++;
      }
   }
   allowedWeapName = [];
   allowedWeapVal = [];
   allowedWeapTeam = [];

   thread watchUsage();
}

watchUsage()
{

	
   usagecount = [];
   for(y=0; y<level.allowedWeapName.size; y++)
   {

      usagecount[level.allowedWeapNameFull[y]] = 0;

   }
      
   while(1)
   {
    //  if(getDvarint("bro_DebugWeapLimit")==1) wait 2;
      players = get_players();
      for (i = 0; i < players.size; i++)
      {
         if(isdefined(players[i].pers["pickweapon"]))
         {
            if(isdefined(usagecount[players[i].pers["pickweapon"]])) 
            {
               usagecount[players[i].pers["pickweapon"]]++;
               
               if(level.fg42stg44Merge > 0)
               {
                  if(players[i].pers["pickweapon"] == "fg42_mp")
                     usagecount["stg44_mp"]++;
                  else if(players[i].pers["pickweapon"] == "stg44_mp")
                     usagecount["fg42_mp"]++;
               }  
               
               if(level.thompsonGreasegunMerge > 0)
               {
                  if(players[i].pers["pickweapon"] == "thompson_mp")
                     usagecount["thompson_mp"]++;
                  else if(players[i].pers["pickweapon"] == "m3a1_mp")
                     usagecount["m3a1_mp"]++;
               }  
            }
            else if(isdefined(usagecount[players[i].pers["pickweapon"] + "_" + game[players[i].pers["team"]]])) 
            {
               usagecount[players[i].pers["pickweapon"] + "_" + game[players[i].pers["team"]]]++;       
            }
         }
      }

    
      for(y=0; y<level.allowedWeapName.size; y++)
      {
         if(usagecount[level.allowedWeapNameFull[y]] < level.allowedWeapVal[y]) 
         {
            level.allowWeapon[level.allowedWeapName[y]] = 1;
            
            usagecount[level.allowedWeapNameFull[y]] = 0;
         }
         else 
         {

            level.allowWeapon[level.allowedWeapName[y]] = 0;
            usagecount[level.allowedWeapNameFull[y]] = 0;
         }        
      }
      wait 1;
    }
}

checkAllowedWeapon(weapon)
{
   if(getDvarInt("bro_limitWeapons") == 0)
      return true;
   
   if(isdefined(self.pers["isBot"]) && self.pers["isBot"] == true)
      return true;
      
   if(level.squadSystem["active"] > 0)
      return true;
      
   weaponTotal = 0;
   weaponSubSection = 0;
   print("Verifying weapon: " + weapon + " for " + self.name + "\n");
   if(isdefined(level.weaponSetLimit[weapon + "_" + game[self.pers["team"]]]))
   {
      limit = level.weaponSetLimit[weapon + "_" + game[self.pers["team"]]];
      uiDvar = "ui_" + level.weaponDvarName[weapon + "_" + game[self.pers["team"]]];
   }
   else
   {
      limit = level.weaponSetLimit[weapon];
      uiDvar = "ui_" + level.weaponDvarName[weapon];
   }
   if(level.fg42stg44Merge > 0 && (weapon == "fg42_mp" || weapon == "stg44_mp"))
      weaponSubSection = 1;
      
   if(level.thompsonGreasegunMerge > 0 && (weapon == "thompson_mp" || weapon == "m3a1_mp"))
      weaponSubSection = 2;
   
   switch(weaponSubSection)
   {
         case 1:
         
            for(i=0; i<level.players.size;i++)
            {
               if(isdefined(level.players[i].pers["pickweapon"]) && level.players[i] != self && level.players[i].pers["team"] == self.pers["team"])
               {
                  if(level.players[i].pers["pickweapon"] == "fg42_mp" || level.players[i].pers["pickweapon"] == "stg44_mp")
                  {
                     weaponTotal++;
                    // self iprintln("^3Match fg42/stg44");
                  }
               }
            }
            
            break;
            
         case 2:
         
            for(i=0; i<level.players.size;i++)
            {
               if(isdefined(level.players[i].pers["pickweapon"]) && level.players[i] != self && level.players[i].pers["team"] == self.pers["team"])
               {
                  if(level.players[i].pers["pickweapon"] == "thompson_mp" || level.players[i].pers["pickweapon"] == "m3a1_mp")
                  {
                     weaponTotal++;
                    // self iprintln("^3Match fg42/stg44");
                  }
               }
            }
            
            break;
            
         default:
            for(i=0; i<level.players.size;i++)
            {
               if(isdefined(level.players[i].pers["pickweapon"]) && level.players[i] != self && level.players[i].pers["team"] == self.pers["team"])
               {
                  if(weapon == level.players[i].pers["pickweapon"])
                  {
                     weaponTotal++;
                   //  self iprintln("^3Matched faction only");
                  }
               }
            }
            
            break;
   }
         
 //  self iprintln("^3" + weaponTotal);
   
   if(weaponTotal < limit)
      return true;
   else
   { 
      self setClientDvars(uiDvar,0);
      return false;
   }
}

setWeaponUIPlayer()
{

   self endon("has_chosen_weapon");
//   self endon("killed_player");
	self endon("spawned");
//	self endon("disconnect");
   self endon("death_or_disconnect");
	level endon("intermission");
	level endon("game_ended");
   
   if(getDvarint("bro_limitWeapons") == 0) return;

   wait 0.05;
   
   for(y=0; y<level.allowedWeapName.size; y++)
   {   
      dvar = "ui_" + level.allowedWeapName[y];
      if(isdefined(self.pers["pickweapon"]))
      {
         if(level.allowedWeapNameFull[y] == self.pers["pickweapon"] || level.allowedWeapNameFull[y] == self.pers["pickweapon"] + "_" + game[self.pers["team"]])
            val = 1;
         else if(level.fg42stg44Merge > 0 && (level.allowedWeapNameFull[y] == "fg42_mp" || level.allowedWeapNameFull[y] == "stg44_mp") && (self.pers["pickweapon"] == "fg42_mp" || self.pers["pickweapon"] == "stg44_mp"))
            val = 1;
         else if(level.thompsonGreasegunMerge > 0 && (level.allowedWeapNameFull[y] == "thompson_mp" || level.allowedWeapNameFull[y] == "m3a1_mp") && (self.pers["pickweapon"] == "thompson_mp" || self.pers["pickweapon"] == "m3a1_mp"))
            val = 1;
         else
            val = level.allowWeapon[level.allowedWeapName[y]];
      }
      else
         val = level.allowWeapon[level.allowedWeapName[y]];
       
      self setClientDvars(dvar,val);
      wait 0.05;
   }
}