init()
{
   /*
   list admin's names below. 
   Increase the number in the square brackets by 1 each time
   Always start with zero.
   
   Admin / moderator names must match in game exactly, including the clan tag
   
   Admins receive warnings in game for:
   
   - Hip Shooting
   - Bad Jumps
   - Jump Shooting
   
   Admins can also use the ingame admin menu which allows them to:
   
   - Fast Restart Map
   - Enable / disable match mode
   - Set the team to defend first in match mode
   - Change team icons
   - Switch players between teams or into spectate
   - Kick players
   
   */
   
   // Full admins - have access to everything
   
   level.adminList[0] = "[Bro]-Robbo";
   level.adminList[1] = "[Bro]-Chris";
   level.adminList[2] = "[Bro]-Jarhead";


   // Moderators - Specify these with info showing the areas they can access.
   
   /* valid areas:
   
         warnings
         fastrestart
         matchmode
         teamicons
         playercontrol
         adminspec
         clanmode
         mapcontrol
   
      Example: (name must always be first)
      
         level.modList[0] = "[Bro]-Robbo;warnings;fastrestart;clanmode";
   */
   
   level.modList[0] = "[Bro]-Crazy;fastrestart;warnings;teamicons;mapcontrol;playercontrol";
   level.modList[1] = "[Bro]-Marsh;fastrestart;warnings;playercontrol";
   level.modList[2] = "[Bro]-puggy;matchmode;fastrestart;warnings;adminspec";
   level.modList[3] = "[Bro]-Jules;fastrestart;warnings";


}