init()
{
   locationNames = [];
   menuNames = [];
   
   mapname = toLower(getdvar("mapname"));
   
   switch(mapname)
   {
/////////////////////////////////////////
      // EDIT FROM HERE
/////////////////////////////////////////
   
      case "mp_seelow":                // add a new 'case' for each map
         locationNames["a"] = &"Barn";  // locationNames must have a '&' in front
         locationNames["b"] = &"Farmers House";
         locationNames["c"] = &"Railroad Bridge";
         locationNames["d"] = &"Back Yard";
         locationNames["e"] = &"Mill";
         menuNames["a"] = "Barn";
         menuNames["b"] = "Farmers House";
         menuNames["c"] = "Railroad Bridge";
         menuNames["d"] = "Back Yard";
         menuNames["e"] = "Mill";
         break;                        // Must have a break; at end of each 'case'
         
     case "mp_castle":                    // add a new 'case' for each map
         locationNames["a"] = &"Orchard";    // locationNames must have a '&' in front
         locationNames["b"] = &"Supply Area";
         locationNames["c"] = &"Dojo";
         locationNames["d"] = &"Main Stairs";
         locationNames["e"] = &"Rock Garden";
         menuNames["a"] = "Orchard";
         menuNames["b"] = "Supply Area";
         menuNames["c"] = "Dojo";
         menuNames["d"] = "Main Stairs";
         menuNames["e"] = "Rock Garden";
         break;                        // Must have a break; at end of each 'case'
         
/////////////////////////////////////////
      // EDIT UP TO HERE
/////////////////////////////////////////
   }
   
   runNameChanges(locationNames,menuNames);

}

runNameChanges(locationNames,menuNames)
{
   ids = [];
   ids[0] = "a";
   ids[1] = "b";
   ids[2] = "c";
   ids[3] = "d";
   ids[4] = "e";
   
   for(i=0; i < ids.size; i++)
   {
      if(isDefined(locationNames[ids[i]]))
         game["strings"]["war_callsign_" + ids[i]] = locationNames[ids[i]];
         
      if(isDefined(menuNames[ids[i]]))
         game["strings_menu"]["war_callsign_" + ids[i]] = menuNames[ids[i]];
   }
}