#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;

setLimits()
{
   precacheString(&"BRM_CHECK_ARTY_STATUS");

   precacheString(&"BRM_PRESS_TO_REARM");
   precacheString(&"BRM_REARMING");
   precacheString(&"BRM_NO_MORE_AMMO");

   precacheString(&"BRM_HOLD_TO_REARM");
   precacheString(&"BRM_REARMING");
   precacheString(&"BRM_CANT_HOLD_MORE_SUPPORT");
   precacheString(&"BRM2_OUT_OF_AMMO");

   precacheItem("at_ammo_mp");
   precacheItem("support_ammo_mp");
   
   precacheShader("compass_objpoint_flak");
   precacheShader("hud_icon_flare"); // binoculars icon strangely enough ;-)

 
   precacheModel("clutter_okinawa_prchute_drpbox");
   precacheModel("static_berlin_wood_ammobox_04");
   
   maps\mp\gametypes\_playerwaypoints::init();
 //  precacheModel("vehicle_usa_pby_exterior"); // this model is le huge :-(
 
   if(game["allies"] == "marines")
   {
      if(game["axis"] == "japanese")
      {
         level.plane["axis"] = "vehicle_jap_airplane_zero2_fly";
         level.plane["allies"] = "vehicle_usa_aircraft_f4ucorsair_dist";
      }
      else
      {
         level.plane["axis"] = "vehicle_stuka_flying";
         level.plane["allies"] = "vehicle_p51_mustang";
      }      
   }
   else
   {
      level.plane["axis"] = "vehicle_stuka_flying";
      level.plane["allies"] = "vehicle_rus_airplane_il2";
   }
         
   precacheModel(level.plane["axis"]);
   precacheModel(level.plane["allies"]);
   level.supplyPlane = [];
   level.supplyBoxDeath = loadfx ("custom/supply_box_death"); // Booosh!
   
   if(getdvar("bro_debug_extra") == "") setdvar("bro_debug_extra",0);
   if(getdvar("bro_autobind") == "") setdvar("bro_autobind",1);
   
   level.debugExtra =  getdvarint("bro_debug_extra");
   
   // Special Officer / mortar interaction
   
   if(getdvar("bro_squads_mortar_officer") == "") setdvar("bro_squads_mortar_officer",0);
   if(getdvar("bro_squads_mortar_nco") == "") setdvar("bro_squads_mortar_nco",0);
   if(getdvar("bro_squads_mortar_usebinoculars") == "") setdvar("bro_squads_mortar_usebinoculars",0);
   if(getdvar("bro_squads_mortar_targetrange") == "") setdvar("bro_squads_mortar_targetrange",560);
   if(getdvar("bro_squads_mortar_bombsite_saferange") == "") setdvar("bro_squads_mortar_bombsite_saferange",450);
   if(getdvar("bro_squads_mortarbarrage_shells") == "") setdvar("bro_squads_mortarbarrage_shells",6); // shells per barrage
   if(getdvar("bro_squads_mortarbarrage_time") == "") setdvar("bro_squads_mortarbarrage_time",40); // max time (Seconds) per barrage
   
   if(getdvar("bro_squads_officer_mortar_dist") == "") setdvar("bro_squads_officer_mortar_dist",200); // Distance between officer and mortar crew to give coordinates
   if(getdvar("bro_squads_officer_radioman_dist") == "") setdvar("bro_squads_officer_radioman_dist",200); // Distance between officer and mortar crew to give coordinates
   
   
   level._mortartargetrange = limitvar(getdvarint("bro_squads_mortar_targetrange"),0,10000);
   level._mortarBarrageTime = limitvar(getdvarfloat("bro_squads_mortarbarrage_time"),5, 4000);
   level._mortarBarrageShells = limitvar(getdvarint("bro_squads_mortarbarrage_shells"),1,50); 
   
   // ~~~~~~~~~~~~~~~~~~~ //
   
   
   if(getdvar("bro_squads_supplydrop_cooldown") == "") setdvar("bro_squads_supplydrop_cooldown",60);
   if(getdvar("bro_squads_smokebarrage_cooldown") == "") setdvar("bro_squads_smokebarrage_cooldown",60);
   if(getdvar("bro_squads_mortarbarrage_cooldown") == "") setdvar("bro_squads_mortarbarrage_cooldown",60);
   if(getdvar("bro_squads_artillery_cooldown") == "") setdvar("bro_squads_artillery_cooldown",60);
   if(getdvar("bro_squads_artillery_allowdangerclose") == "") setdvar("bro_squads_artillery_allowdangerclose",0);
   
   if(getdvar("bro_squads_airsupport_cooldown") == "") setdvar("bro_squads_airsupport_cooldown",100);
   
   if(getdvar("bro_squads_airsupport_predelay") == "") setdvar("bro_squads_airsupport_predelay",13);
   
   if(getdvar("bro_squads_supplydrop_count") == "") setdvar("bro_squads_supplydrop_count",3);
   if(getdvar("bro_squads_artillery_count") == "") setdvar("bro_squads_artillery_count",4);
   if(getdvar("bro_squads_mortarbarrage_count") == "") setdvar("bro_squads_mortarbarrage_count",4);
   if(getdvar("bro_squads_strafing_count") == "") setdvar("bro_squads_strafing_count",3);
   if(getdvar("bro_squads_bomb_count") == "") setdvar("bro_squads_bomb_count",3);
   if(getdvar("bro_squads_napalm_count") == "") setdvar("bro_squads_napalm_count",2);
   if(getdvar("bro_squads_phosphorous_count") == "") setdvar("bro_squads_phosphorous_count",2);
   if(getdvar("bro_squads_smokebarrage_count") == "") setdvar("bro_squads_smokebarrage_count",4);
      
   if(getdvar("bro_squads_supplies_clips") == "") setdvar("bro_squads_supplies_clips",20);
   if(getdvar("bro_squads_supplies_antitank") == "") setdvar("bro_squads_supplies_antitank",8);
   if(getdvar("bro_squads_supplies_grenades") == "") setdvar("bro_squads_supplies_grenades",4);
   if(getdvar("bro_squads_supplies_smokes") == "") setdvar("bro_squads_supplies_smokes",2);
   if(getdvar("bro_squads_supplies_support") == "") setdvar("bro_squads_supplies_support",4);
   if(getdvar("bro_squads_supplies_medkits") == "") setdvar("bro_squads_supplies_medkits",10);
   
   if(getdvar("bro_artillery_tkpunish") == "") setdvar("bro_artillery_tkpunish",1);
   
   if(getdvar("bro_squads_sightingAdjustment_" + toLower(getDvar("mapname"))) == "") setdvar("bro_squads_sightingAdjustment_" + toLower(getDvar("mapname")),0);
   
   if(getdvarint("bro_squads_sightingAdjustment_" + toLower(getDvar("mapname"))) == 0)
      level.checkSkyCap = true;
   else
      level.checkSkyCap = false;
      
   level.supplyBox["clips"] = getdvarint("bro_squads_supplies_clips");
   level.supplyBox["antitank"] = getdvarint("bro_squads_supplies_antitank");
   level.supplyBox["grenades"] = getdvarint("bro_squads_supplies_grenades");
   level.supplyBox["smokes"] = getdvarint("bro_squads_supplies_smokes");
   level.supplyBox["support"] = getdvarint("bro_squads_supplies_support");
   level.supplyBox["medkits"] = getdvarint("bro_squads_supplies_medkits");
   
   level.artycooldown = getdvarint("bro_squads_artillery_cooldown");
   level.artyDangerClose = getdvarint("bro_squads_artillery_allowdangerclose");
   level.artycalltime = 5;
   
   level.supplyBoxRadius = 50;
   level.supplyDropCooldown = getdvarint("bro_squads_supplybox_cooldown");
   level.smokeBarrageCooldown = getdvarint("bro_squads_smokebarrage_cooldown");
   level.mortarBarrageCooldown = getdvarint("bro_squads_mortarbarrage_cooldown");
   
   level.airsupportCooldown = getdvarint("bro_squads_airsupport_cooldown");
   level.airsupportpredelay = getdvarint("bro_squads_airsupport_predelay");
      
   if(!isdefined(game["artyStrikes"]))
   {       
      game["artyStrikes"] = [];
   
      game["artyStrikes"]["allies"]["max"] = getdvarint("bro_squads_artillery_count");
      game["artyStrikes"]["axis"]["max"] = getdvarint("bro_squads_artillery_count");
   }
   
   if(!isdefined(game["supplyDrops"]))
   {       
      game["supplyDrops"] = [];
   
      game["supplyDrops"]["allies"]["max"] = getdvarint("bro_squads_supplydrop_count");
      game["supplyDrops"]["axis"]["max"] = getdvarint("bro_squads_supplydrop_count");
   }
   
   if(!isdefined(game["smokebarrage"]))
   {       
      game["smokebarrage"] = [];
   
      game["smokebarrage"]["allies"]["max"] = getdvarint("bro_squads_smokebarrage_count");
      game["smokebarrage"]["axis"]["max"] = getdvarint("bro_squads_smokebarrage_count");
   }
   if(!isdefined(game["mortarbarrage"]))
   {       
      game["mortarbarrage"] = [];
   
      game["mortarbarrage"]["allies"]["max"] = getdvarint("bro_squads_mortarbarrage_count");
      game["mortarbarrage"]["axis"]["max"] = getdvarint("bro_squads_mortarbarrage_count");
   }
   
   if(!isdefined(game["strafing"]))
   {       
      game["strafing"] = [];
   
      game["strafing"]["allies"]["max"] = getdvarint("bro_squads_strafing_count");
      game["strafing"]["axis"]["max"] = getdvarint("bro_squads_strafing_count");
      
      game["bomb"] = [];
   
      game["bomb"]["allies"]["max"] = getdvarint("bro_squads_bomb_count");
      game["bomb"]["axis"]["max"] = getdvarint("bro_squads_bomb_count");
      
      game["napalm"] = [];
   
      game["napalm"]["allies"]["max"] = getdvarint("bro_squads_napalm_count");
      game["napalm"]["axis"]["max"] = getdvarint("bro_squads_napalm_count");
      
      game["phos"] = [];
      
      game["phos"]["allies"]["max"] = getdvarint("bro_squads_phosphorous_count");
      game["phos"]["axis"]["max"] = getdvarint("bro_squads_phosphorous_count");
   }
   
   game["artyStrikes"]["allies"]["cooldown"] = level.artycooldown;
   game["artyStrikes"]["axis"]["cooldown"] = level.artycooldown;
   
   game["artyStrikes"]["allies"]["isfiring"] = false;
   game["artyStrikes"]["axis"]["isfiring"] = false;
   
   game["supplyDrops"]["allies"]["cooldown"] = level.supplyDropCooldown;
   game["supplyDrops"]["axis"]["cooldown"] = level.supplyDropCooldown;
   
//   game["smokebarrage"]["allies"]["cooldown"] = level.smokeBarrageCooldown;
   game["smokebarrage"]["allies"]["cooldown"] = 0;
//   game["smokebarrage"]["axis"]["cooldown"] = level.smokeBarrageCooldown;
   game["smokebarrage"]["axis"]["cooldown"] = 0;
   
   game["mortarbarrage"]["allies"]["cooldown"] = level.mortarBarrageCooldown;
   game["mortarbarrage"]["axis"]["cooldown"] = level.mortarBarrageCooldown;
   
   game["airsupport"]["allies"]["cooldown"] = level.airsupportCooldown;
   game["airsupport"]["axis"]["cooldown"] = level.airsupportCooldown;
   
   if(getdvar("bro_squads_atammoCount") == "") setdvar("bro_squads_atammoCount",7);  
   if(getdvar("bro_squads_supportammoCount") == "") setdvar("bro_squads_supportammoCount",5);  
   if(getdvar("bro_squads_rearmTime") == "") setdvar("bro_squads_rearmTime",1);
   
   game["extra_rearmtime"] = getdvarfloat("bro_squads_rearmTime");   
   game["extra_at"] = getdvarint("bro_squads_atammoCount");
   game["extra_support"] = getdvarint("bro_squads_supportammoCount");
   
   game["extra_at"] = limitVar(game["extra_at"],1,30);
   game["extra_support"] = limitVar(game["extra_support"],1,30);
   game["extra_rearmtime"] = limitVar(game["extra_rearmtime"],0.5,25);

   if(getdvar("bro_squads_bettyloadout") == "") setdvar("bro_squads_bettyloadout",2);
      
   game["bettycount"] = getdvarint("bro_squads_bettyloadout");
   
   game["bettycount"] = limitVar(game["bettycount"],1,5);
   
   if(getdvar("bro_radioman_pointreward") == "") setdvar("bro_radioman_pointreward",3);      // points to reward radiomen for calling in support

   game["weapons"] = [];  
   game["weapons"]["support"] = [];
   game["weapons"]["antitank"] = [];
   
   game["weapons"]["support"][0] = "30cal_bipod_mp";
   game["weapons"]["support"][1] = "bar_mp";
   game["weapons"]["support"][2] = "type99lmg_bipod_mp";
   game["weapons"]["support"][3] = "mg42_bipod_mp";
   game["weapons"]["support"][4] = "dp28_bipod_mp";
   game["weapons"]["support"][5] = "bar_bipod_mp";
   
   
   game["weapons"]["antitank"][0] = "bazooka_mp";
   game["weapons"]["antitank"][1] = "panzershrek_mp";
   game["weapons"]["antitank"][2] = "ptrs41_mp";
   game["weapons"]["antitank"][3] = "mortar_mp";

   thread maps\mp\gametypes\_airsupport::init();
   thread maps\mp\gametypes\_mortars::init();
    
   level thread reduceCoolDown("artyStrikes","allies","cooldown");
   level thread reduceCoolDown("artyStrikes","axis","cooldown");
   
   level thread reduceCoolDown("mortarbarrage","allies","cooldown");
   level thread reduceCoolDown("mortarbarrage","axis","cooldown");
   
   level thread reduceCoolDown("supplyDrops","allies","cooldown");
   level thread reduceCoolDown("supplyDrops","axis","cooldown");
   
   level thread reduceCoolDown("airsupport","allies","cooldown");
   level thread reduceCoolDown("airsupport","axis","cooldown");
   
   level thread reduceCoolDown("smokebarrage","allies","cooldown");
   level thread reduceCoolDown("smokebarrage","axis","cooldown");
   
 //  maps\mp\gametypes\_supplydropzeroy::precache();

//   level thread flyPlane((-3510,1648,0), 45, "allies"); // debug lols
}

giveItem(hasPistol)
{
   self.hasArtyBinoculars = false;
   self.hasNcoBinoculars = false;
   self.isAMedic = false;
   self.numHeals = level.maxHeals;
   hasWayPoints = false;
   
   team = self.pers["team"];
   
   pistol = "";
   
   if(hasPistol)
   {
      pistol = maps\mp\gametypes\_weapons::factionPistol(game[team]);  
   }  

   if(level.squadSystem["active"] == 1)
      extra = int(game["squadsystem"][team]["extras"][self.pers["chosensquad"]][self.pers["chosenclass"]][self.pers["chosenweapon"]]);
	else
      extra = int(game["classsystem"][team][self.pers["chosenclass"]]["extras"][self.pers["chosenweapon"]]);

	if(extra > 0 && isdefined(level.squadSystemWeapons[extra]))
	{
      if(level.squadSystemWeapons[extra]  == "arty_binoculars_mp" || level.squadSystemWeapons[extra] == "nco_binoculars_mp")
      {
         hasWayPoints = true;
         weapon = "binoculars_mp";
         
         if(hasPistol && level.squadSystemWeapons[extra]  == "arty_binoculars_mp" && getdvarint("bro_officer_revolver") > 0)
            pistol = "357magnum_mp";
      }
      else
         weapon = level.squadSystemWeapons[extra];
        
         self giveWeapon( weapon );
         self SetActionSlot(3,"weapon",weapon);
	   
	   if(level.squadSystemWeapons[extra]  == "arty_radio_mp")
	   {
         hasWayPoints = true;
         self thread watchItemUse("arty_radio_mp");
      }
      else if(level.squadSystemWeapons[extra] == "arty_binoculars_mp")
      {
         self thread watchItemUse("binoculars_mp"); 
         self.hasArtyBinoculars = true;
      }
      else if(level.squadSystemWeapons[extra] == "nco_binoculars_mp")
      {
         self thread watchItemUse("binoculars_mp");
         self.hasNcoBinoculars = true;     
      }
      
      if(level.squadSystemWeapons[extra] == "syrette_mp")
      {
         self.isAMedic = true;
         
         if(!game["bromode"])
            self thread maps\mp\gametypes\_medics::preloadHud();
         
         self setWeaponAmmoClip( "syrette_mp", level.medicKitCount );
         self.totalRestorePoints = level.medicKitCount * level.medicKitPoints;     
      }
      else if(level.squadSystemWeapons[extra] == "at_ammo_mp")
      {
         hasWayPoints = true;
         self setWeaponAmmoClip( "at_ammo_mp", game["extra_at"] );  
      }   

      else if(level.squadSystemWeapons[extra] == "support_ammo_mp")
      {
         hasWayPoints = true;
         self setWeaponAmmoClip( "support_ammo_mp", game["extra_support"] );  
      }
         
      else if(level.squadSystemWeapons[extra] == "mine_bouncing_betty_mp")
         self setWeaponAmmoClip( "mine_bouncing_betty_mp", game["bettycount"] );          
	}
       
	self.calledMedic = false;
	self.beenMarked = false;
	self.myofficer = undefined;
	self.medic = undefined;

	if(pistol != "")
      self giveweapon(pistol);
	
	if(hasWayPoints)
      self thread maps\mp\gametypes\_playerwaypoints::setup();
   else
   {
      self setclientdvars("waypointIconHeight","18",
                     "waypointIconWidth","18",
                     "waypointOffscreenPadLeft", "0",
                     "waypointOffscreenPadBottom", "55",
                     "waypointOffscreenPointerDistance", "14",
                     "waypointOffscreenPointerHeight", "8",
                     "waypointOffscreenPointerWidth", "12");
   }
}

giveCoax()
{  
   self endon("death_or_disconnect");
   wait 1;
   self setperk("specialty_boost");
   self.extraPerks[ "specialty_boost" ] = 1;
}
watchItemUse(type)
{
   self endon("killed_player");
	self endon("spawned");
	self endon("disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	//self thread radioCleanup();
	
	// arty status flags 
   // 0 = out of ammo
   // 1 = reloading
   // 2 = firing
   // 3 = ready
   // 4 = unknown
   
   self.artyStatus = 4; // Er, whats going on again?

	self.coordinates = [];
	self.coordinates["artillery"] = undefined;
	self.coordinates["supplies"] = undefined;
	self.coordinates["airsupport"] = undefined;
	self.officer = [];
	self.officer["artillery"] = undefined;
	self.officer["supplies"] = undefined;
	self.officer["airsupport"] = undefined;
	self.radioSupportCategory = undefined;
	
	self thread maps\mp\gametypes\_radiooperations::opHud(type);

}

radioCleanup() // remove the radio hudicons foshizzle!
{
   if(isdefined(self.radioStatus))
      self.radioStatus destroy();
   
   if(isdefined(self.statusLabel))
      self.statusLabel destroy();
      
   self maps\mp\gametypes\_mortars::cleanupMortarHud();
}

   
reduceCoolDown(firstArg, secondArg, thirdArg)
{
   level endon("intermission");
	level endon("game_ended");
	
	while(1)
	{  
    //  prevValue = game[firstArg][secondArg][thirdArg];
      
      wait 1;
      
      if(game[firstArg][secondArg][thirdArg] > 0)
      {  
         game[firstArg][secondArg][thirdArg]--;
         
         if(game[firstArg][secondArg][thirdArg] == 0)
         {
            thread maps\mp\gametypes\_radiooperations::globalRefresh(secondArg, firstArg);
         }
      }  
	}
}	

bipodOpHud()
{
//   self endon("killed_player");
	self endon("spawned");
	//self endon("disconnect");
	self endon("perks_hidden");
	self endon("death_or_disconnect");
	level endon("intermission");
	level endon("game_ended");
	
	if(getdvarint("bro_autobind") == 1)
      self ExecClientCommand("bind 9 openScriptMenu radiomenu load"); // common bind for revised brm
	/*
   if(!isdefined(self.statusLabel))
   {
      self.statusLabel = newClientHudElem(self);
      self.statusLabel.horzAlign = "left";
      self.statusLabel.vertAlign = "top";
      self.statusLabel.x = 183;
      self.statusLabel.y = 10;
      self.statusLabel.alignX = "left";
      self.statusLabel.alignY = "top";
      self.statusLabel.font = "default";
      self.statusLabel.fontscale = 1;
      self.statusLabel.archived = false;
   }*/
   
   while(1)
   {
      weapon = self GetCurrentWeapon();

      if((isSubStr(weapon,"_bipod_") || weapon == "mortar_mp" || weapon == "ptrs41_mp") && !isDefined(self GetVehicleOccupied()))
      {
         if((isSubStr(weapon,"_bipod_") || weapon == "ptrs41_mp" ) && self GetStance() != "prone" )
         {
         //   self.statusLabel settext(&"BRM2_PRONETO_DEPLOY_BIPOD");
            self setclientdvars("ui_statustext",2);
         }
         else
         {
        //    self.statusLabel settext(&"BRM_DEPLOY_BIPOD");
            self setclientdvars("ui_statustext",1);
         }
        // self.statusLabel.alpha = 1;   
      }
      else if(self.startedWithDeployableMG)
      {
         closest = undefined;
         
         for(i=0; i < level.deployedTurretArray.size; i++)
         {
            turret = level.deployedTurretArray[i];
            
          //  dist = distanceSquared(self.origin, turret.origin);
            
            if(distanceSquared(self.origin, turret.origin) < 3600 && !isDefined(turret.user))
               closest = turret;    
         }
         
         if(isDefined(closest) && !isDefined(self GetVehicleOccupied()))
         {
            self.targetTurret = closest;
          //  self.statusLabel settext(&"BRM_PICKUP_BIPOD");
          //  self.statusLabel.alpha = 1;  
            self setclientdvars("ui_statustext",3);
         }
         else
         {
            if(!isDefined(self.radioStatus))
            {
            //   self.statusLabel.alpha = 0; 
            
               self setclientdvars("ui_statustext",0);
            }
            self.targetTurret = undefined;
         } 
      }
      else if(self.startedWithDeployableMortar)
      {
         closest = undefined;
         
         for(i=0; i < level.deployedMortars.size; i++)
         {
            mortar = level.deployedMortars[i];
 
            if(!isDefined(mortar.owner) || mortar.owner == self)
            {
               dist = distanceSquared(self.origin, mortar.origin);
               if(dist < 3600)
               {
                  if( !isDefined(closest))
                     closest = mortar;
                  else if(dist < distanceSquared(self.origin, closest.origin))
                     closest = mortar;
               }
            }
            
         //   if(distanceSquared(self.origin, mortar.origin) < 3600 && !isDefined(mortar.owner))
          //     closest = mortar;    
         }
         
         if(isDefined(closest) && !isDefined(self GetVehicleOccupied()))
         {
            self.targetMortar = closest;
         //   self.statusLabel settext(&"BRM_PICKUP_BIPOD");
        //    self.statusLabel.alpha = 1;  
            self setclientdvars("ui_statustext",3);
         }
         else
         {
            if(!isDefined(self.radioStatus))
            {
         //      self.statusLabel.alpha = 0; 
               
               self setclientdvars("ui_statustext",0);
            }
            self.targetMortar = undefined;
         } 
      }
      else
      {
         if(!isDefined(self.radioStatus))
         {
         //   self.statusLabel.alpha = 0;
            
            self setclientdvars("ui_statustext",0);
         }
      }
      wait 0.2;
   }
}   
	