init()
{
	game["menu_team"] = "team_marinesopfor";
	game["menu_class_allies"] = "class_marines";
	game["menu_changeclass_allies"] = "changeclass_marines";
	game["menu_initteam_allies"] = "initteam_marines";
	game["menu_class_axis"] = "class_opfor";
	game["menu_changeclass_axis"] = "changeclass_opfor";
	game["menu_initteam_axis"] = "initteam_opfor";
	game["menu_class"] = "class";
	game["menu_changeclass"] = "changeclass";
	game["menu_changeclass_offline"] = "changeclass_offline";
	
	game["menu_welcome"] = "welcome";
	
	game["menu_changeclass_allies"] = "changeclass_american";
	game["menu_changeclass_axis"] = "changeclass_german";
	
	if(game["allies"]=="russian") game["menu_changeclass_allies"] = "changeclass_russian";
	if(game["axis"]=="japanese") game["menu_changeclass_axis"] = "changeclass_japanese";
	
	game["menu_adminoptions"] = "adminoptions";
	game["menu_admin_teamicons"] = "admin_teamicons";
	game["menu_admin_playerlist"] = "admin_playerlist";
	game["menu_admin_clanmode"] = "admin_clanmode";
	game["menu_admin_maps"] = "admin_maps";
	
	game["menu_radiomenu"] = "radiomenu";
	game["menu_binocular"] = "binocular";
	game["menu_ncobinocular"] = "ncobinocular";
	game["menu_airsupport"] = "airsupport";
    
	if ( !level.console )
	{
		game["menu_callvote"] = "callvote";
		game["menu_muteplayer"] = "muteplayer";
		precacheMenu(game["menu_callvote"]);
		precacheMenu(game["menu_muteplayer"]);
		
		
		// ---- back up one folder to access game_summary.menu ----
		// game summary menu file precache
		game["menu_eog_main"] = "endofgame";
		
		// menu names (do not precache since they are in game_summary_ingame which should be precached
		game["menu_eog_unlock"] = "popup_unlock";
		game["menu_eog_summary"] = "popup_summary";
		game["menu_eog_unlock_page1"] = "popup_unlock_page1";
		game["menu_eog_unlock_page2"] = "popup_unlock_page2";
	/*	
		precacheMenu(game["menu_eog_main"]);
		precacheMenu(game["menu_eog_unlock"]);
		precacheMenu(game["menu_eog_summary"]);
		precacheMenu(game["menu_eog_unlock_page1"]);
		precacheMenu(game["menu_eog_unlock_page2"]);
		*/
	
	}
	else
	{
		game["menu_controls"] = "ingame_controls";
		game["menu_options"] = "ingame_options";
		game["menu_leavegame"] = "popup_leavegame";

		if(level.splitscreen)
		{
			game["menu_team"] += "_splitscreen";
			game["menu_class_allies"] += "_splitscreen";
			game["menu_changeclass_allies"] += "_splitscreen";
			game["menu_class_axis"] += "_splitscreen";
			game["menu_changeclass_axis"] += "_splitscreen";
			game["menu_class"] += "_splitscreen";
			game["menu_changeclass"] += "_splitscreen";
			game["menu_controls"] += "_splitscreen";
			game["menu_options"] += "_splitscreen";
			game["menu_leavegame"] += "_splitscreen";
		}

		precacheMenu(game["menu_controls"]);
		precacheMenu(game["menu_options"]);
		precacheMenu(game["menu_leavegame"]);
	}

	precacheMenu("scoreboard");
	precacheMenu(game["menu_team"]);
	precacheMenu(game["menu_class_allies"]);
	precacheMenu(game["menu_changeclass_allies"]);
	precacheMenu(game["menu_initteam_allies"]);
	precacheMenu(game["menu_class_axis"]);
	precacheMenu(game["menu_changeclass_axis"]);
	precacheMenu(game["menu_class"]);
	precacheMenu(game["menu_changeclass"]);
	precacheMenu(game["menu_initteam_axis"]);
//	precacheMenu(game["menu_changeclass_offline"]);
//	precacheMenu(game["menu_changeclass_american"]);


   precacheMenu("squadloadout_american");
   precacheMenu("squadloadout_ro");
   
   if(level.squadSystem["active"] == 1)
      game["squadloadout_menu"] = "squadloadout_american";
   else
      game["squadloadout_menu"] = "squadloadout_ro";
   
   precacheMenu(game["menu_radiomenu"]);
   precacheMenu(game["menu_binocular"]);
   precacheMenu(game["menu_ncobinocular"]);
   precacheMenu(game["menu_airsupport"]);
	
	precacheMenu("sendcmd");

	precacheMenu(game["menu_welcome"]);
	precacheMenu(game["menu_adminoptions"]);
	precacheMenu(game["menu_admin_teamicons"]);
	precacheMenu(game["menu_admin_playerlist"]);
	precacheMenu(game["menu_admin_clanmode"]);
	precacheMenu(game["menu_admin_maps"]);
	
	precacheString( &"MP_HOST_ENDED_GAME" );
	precacheString( &"MP_HOST_ENDGAME_RESPONSE" );

	level thread onPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player setClientDvar("ui_3dwaypointtext", "1");
		player.enable3DWaypoints = true;
		player setClientDvar("ui_deathicontext", "1");
		player.enableDeathIcons = true;
		
		player thread onMenuResponse();
	}
}

onMenuResponse()
{
	self endon("disconnect");
	self notify("has_chosen_weapon");
	for(;;)
	{
		self waittill("menuresponse", menu, response);
		
	//	iprintln( self getEntityNumber() + " menuresponse: " + menu + " " + response );
		
	//	iprintln("^6" + menu + " :: " + response); 
	//	iprintln("^6" + response); 
		/*if(response == "open_changeclass_menu" )
		{
			if( getDvarInt( "onlinegame" ) )
				self openMenu( "changeclass" );
			else
				self openMenu( "changeclass_offline" );
		}
		*/  
			
		if ( response == "back" )
		{
			self closeMenu();
			self closeInGameMenu();
			self notify("has_chosen_weapon");

			if ( level.console )
			{
				if( menu == game["menu_changeclass"] || menu == game["menu_changeclass_offline"] || menu == game["menu_team"] || menu == game["menu_controls"] )
				{
//					assert(self.pers["team"] == "allies" || self.pers["team"] == "axis");
               self thread maps\mp\gametypes\_weaponlimiter::setWeaponUIPlayer();
					if( self.pers["team"] == "allies" )
						self openMenu( game["menu_class_allies"] );
					if( self.pers["team"] == "axis" )
						self openMenu( game["menu_class_axis"] );
				}
				else if ( menu == "class" )
				{
					self [[level.showsquadinfo]]();
				}
				
			}
			continue;
		}
		
		if(menu == "radiomenu")
		{    
         weap = self GetCurrentWeapon();
         
         if(weap == "arty_radio_mp"  && level.squadSystem["active"] > 0)
         {
            if(response == "load")
            {
               self maps\mp\gametypes\_radiooperations::refreshChoices("radioop");
               self openMenu(game["menu_radiomenu"]);        
            }
            else if(response == "status")
            {
             //  self thread maps\mp\gametypes\_extraloadout::getArtyStatus();
               self thread maps\mp\gametypes\_radiooperations::getArtyStatus();
            }
            else if(response == "firemission")
            {
             //  self thread maps\mp\gametypes\_extraloadout::callFireMission();            
               self thread maps\mp\gametypes\_radiooperations::callFireMission();            
            }
            else if(response == "supply")
            {
            //   self thread maps\mp\gametypes\_extraloadout::callSupplyDrop();
               self thread maps\mp\gametypes\_radiooperations::callSupplyDrop();
            }
            else if(response == "ncosmokebarrage")
            {
             //  self thread maps\mp\gametypes\_extraloadout::callSmokeBarrage();
               self thread maps\mp\gametypes\_radiooperations::callSmokeBarrage();
            }
            else if(response == "airsupport")
            {
              // self thread maps\mp\gametypes\_extraloadout::callAirSupport();
               self thread maps\mp\gametypes\_radiooperations::callAirSupport();
            }
         //   else if(response == "bomb")
        //    {
        //       self thread maps\mp\gametypes\_extraloadout::callBombingRun();
        //    } 
         }
         else if(response == "load" && self.sessionstate == "playing")
         {
            if(weap == "binoculars_mp" && level.squadSystem["active"] > 0 && (self.hasArtyBinoculars || self.hasNcoBinoculars))
            {
               if(self.hasArtyBinoculars)
               {
                  self maps\mp\gametypes\_radiooperations::refreshChoices("officer");
                  self openMenu(game["menu_binocular"]);         
               }
               else if(self.hasNcoBinoculars)
               {
                  self maps\mp\gametypes\_radiooperations::refreshChoices("nco");
                  self openMenu(game["menu_ncobinocular"]);        
               }
            }
            else if(isSubStr(weap,"_bipod_") || weap == "ptrs41_mp")
            {
               self thread maps\mp\gametypes\_bipods::deployBipod();        
            }
            else if(self.startedWithDeployableMG)
            {
               self thread maps\mp\gametypes\_bipods::pickupBipod();         
            }
            else if(weap == "mortar_mp")
            {
               self thread maps\mp\gametypes\_mortars::deployMortar();
            } 
            else if(self.startedWithDeployableMortar)
            {
               self thread maps\mp\gametypes\_mortars::pickupMortar();         
            }  
         }
         if(response == "bandaging")
         {
          //  self iprintln("Bandaging");
            self thread maps\mp\gametypes\_usefunctions::selfBandagingBind();
         }
         else if(response == "unjamgun")
         {
            self thread maps\mp\gametypes\_usefunctions::handle_gunJam();
         }
         else if(response == "increasedist")
         {
            self thread maps\mp\gametypes\_mortars::modPos(1);
         }
         else if(response == "reducedist")
         {
            self thread maps\mp\gametypes\_mortars::modPos(-1);
         }
         else if(response == "mortarswitchmode")
         {
            self thread maps\mp\gametypes\_mortars::toggleMode();
         }
       }
       else if(level.squadSystem["active"] > 0 && self GetCurrentWeapon() == "binoculars_mp")
       {
         if(self.hasArtyBinoculars)
         {
            if(menu == "binocular")
            {
               if(response == "load")
               {
                  self openMenu(game["menu_binocular"]);        
               }
               else if(response == "markarty")
               {
                  self thread maps\mp\gametypes\_radiooperations::getCoordinates("artillery");
               }
               else if(response == "markmortar")
               {
                  self thread maps\mp\gametypes\_radiooperations::markMortar();
               }
               else if(response == "marksupply")
               {
             //     self thread maps\mp\gametypes\_extraloadout::getCoordinates("supplies");   
               }
               else if(response == "supplycurrentpos")
               {
              //    self thread maps\mp\gametypes\_extraloadout::giveCoordinates(self.origin, "supplies");         
               }
               else if(response == "airsupport")
               {
                  self maps\mp\gametypes\_radiooperations::refreshChoices("airsupport");
               //   self openMenu( game["menu_airsupport"]);     
               }   
            }
            else if(menu == "airsupport")
            {            
               if(response == "strafing" && (level.airSupportHash & 1))
               {
                  self thread maps\mp\gametypes\_radiooperations::giveCoordinates(self.origin, "strafing");
               }
               else if(response == "bomb" && level.airSupportHash & 2)
               {
                  self thread maps\mp\gametypes\_radiooperations::mapSelection("bomb");
               } 
               else if(response == "napalm" && level.airSupportHash & 4)
               {
                  self thread maps\mp\gametypes\_radiooperations::mapSelection("napalm");
               } 
               else if(response == "phos" && level.airSupportHash & 16)
               {
                  self thread maps\mp\gametypes\_radiooperations::mapSelection("phos");
               } 
            }    
         }  
       //  else if(self GetCurrentWeapon() == "binoculars_mp" && self.hasNcoBinoculars == true)
         else if(self.hasNcoBinoculars == true)
         {
            if(menu == "ncobinocular")
            {
               if(response == "load")
               {
                  self maps\mp\gametypes\_radiooperations::refreshChoices("nco");
                  self openMenu(game["menu_ncobinocular"]);        
               }
               else if(response == "markmortar")
               {
                  self thread maps\mp\gametypes\_radiooperations::markMortar();
               }
               else if(response == "smokebarrage")
               {
                  self thread maps\mp\gametypes\_radiooperations::getCoordinates("smokebarrage");
               }
               else if(response == "marksupply")
               {
                  self thread maps\mp\gametypes\_radiooperations::getCoordinates("supplies");   
               }
               else if(response == "supplycurrentpos")
               {        
                  self thread maps\mp\gametypes\_radiooperations::giveCoordinates(self.origin, "supplies");         
               }  
            }
         }
             
      }

      
//===========  ADMIN  ==========//		
   
      if(self.pers["admin"] == true)
      {
         if(response == "admin_loadmenu")
         {
            self thread maps\mp\gametypes\_admin::loadAdmin(); 
            self openMenu( game["menu_adminoptions"]);
         }
         
         else if(response == "admin_teamicons" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_teamicons"])))
         {
            self closeMenu();
            self closeInGameMenu();

            self openMenu( game["menu_admin_teamicons"]);
            self.pers["admin_teamicons_offset"] = 0;
            self thread maps\mp\gametypes\_admin::loadTeamIcons();   
         }
         
         else if(response == "admin_icons_nextpage" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_teamicons"])))
         {        
            self.pers["admin_teamicons_offset"]+= 20;
            self thread maps\mp\gametypes\_admin::loadTeamIcons();       
         }
         
         else if(response == "admin_icons_previouspage" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_teamicons"])))
         {
            if(self.pers["admin_teamicons_offset"] >= 20)
               self.pers["admin_teamicons_offset"]-= 20;
               
            self thread maps\mp\gametypes\_admin::loadTeamIcons();
         }
         
         else if(IsSubStr(response, "admin_selectedicon" ) && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_teamicons"])))
         {
            self thread maps\mp\gametypes\_admin::savePickedIcon(response);      
         }
         
         else if(response == "chosenIconAllied" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_teamicons"])))
         {
            self thread maps\mp\gametypes\_admin::setIcon("allies");
         }
         
         else if(response == "chosenIconAxis" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_teamicons"])))
         {
            self thread maps\mp\gametypes\_admin::setIcon("axis");
         }
         
         else if(response == "admin_fastrestart" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_fastrestart"])))
         {
            self closeMenu();
            self closeInGameMenu();

            self thread maps\mp\gametypes\_admin::fastRestart();
         }
         else if(response == "admin_freespectate" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_adminspec"])))
         {
            self closeMenu();
            self closeInGameMenu();

            self thread maps\mp\gametypes\_admin::setAdminSpectate();
         }
         
         else if(response == "admin_showplayerlist" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_playercontrol"])))
         {
            self closeMenu();
            self closeInGameMenu();

            self openMenu( game["menu_admin_playerlist"] );
            self.pers["admin_playerlist_offset"] = 0;
            self thread maps\mp\gametypes\_admin::loadPlayerList();   
         }
         
         else if(response == "admin_players_nextpage" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_playercontrol"])))
         {
            self.pers["admin_playerlist_offset"]+= 20;
            self thread maps\mp\gametypes\_admin::loadPlayerList();       
         }
         
         else if(response == "admin_players_previouspage" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_playercontrol"])))
         {
            if(self.pers["admin_playerlist_offset"] >= 20)
               self.pers["admin_playerlist_offset"]-= 20;
               
            self thread maps\mp\gametypes\_admin::loadPlayerList();
         }
         
         else if(response == "admin_players_refresh" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_playercontrol"])))
         {
               self thread maps\mp\gametypes\_admin::loadPlayerList();
         }
         
         else if(IsSubStr(response, "admin_selectedplayer" ) && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_playercontrol"])))
         {
            self thread maps\mp\gametypes\_admin::savePickedPlayer(response);      
         }
         
         else if(issubstr(response,"admin_player_switchteam_") && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_playercontrol"])))
         {
            self thread maps\mp\gametypes\_admin::switchPlayerTeam(response); 
            self thread maps\mp\gametypes\_admin::loadPlayerList();     
         }
         
         else if(response == "admin_player_kick" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_playercontrol"])))
         {
            self closeMenu();
            self closeInGameMenu();

            self thread maps\mp\gametypes\_admin::kickPlayer(); 
         }
         
         //===============================//
         
         else if(response == "admin_loadclanmode" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_clanmode"])))
         {
            self closeMenu();
            self closeInGameMenu();

            self openMenu( game["menu_admin_clanmode"] );
            self thread maps\mp\gametypes\_admin::loadClanMenu();   
         }
         
         else if(response == "admin_clanmode_load_en" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_clanmode"])))
         {
            self thread maps\mp\gametypes\_admin::loadClanMenu();   
         }
         
         else if(response == "admin_clanmode_enable" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_clanmode"])))
         {
            self thread maps\mp\gametypes\_admin::changeClanMode(true);   
         }
         
         else if(response == "admin_clanmode_disable" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_clanmode"])))
         {
            self thread maps\mp\gametypes\_admin::changeClanMode(false);  
            	
         }
         
         else if((response == "admin_clanmode_clan_allies" || response == "admin_clanmode_clan_axis" || response == "admin_clanmode_clan_both")
          && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_clanmode"])))
         {
            self thread maps\mp\gametypes\_admin::setTeam("clan",response); 
         }
         else if((response == "admin_clanmode_pubb_allies" || response == "admin_clanmode_pubb_axis" || response == "admin_clanmode_pubb_both") 
          && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_clanmode"])))
         {
            self thread maps\mp\gametypes\_admin::setTeam("pub",response); 
         }
         
         //=================================//
         
         else if(response == "admin_loadmaps" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_mapcontrol"])))
         {
            self closeMenu();
            self closeInGameMenu();

            self openMenu( game["menu_admin_maps"] );
            self thread maps\mp\gametypes\_admin::loadMapMenu();
         }
         
         else if(response == "admin_maps_load_gt" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_mapcontrol"])))
         {
            self thread maps\mp\gametypes\_admin::showHideGtList();
         }
         
         else if(response == "admin_maps_load_maplist" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_mapcontrol"])))
         {
            self thread maps\mp\gametypes\_admin::showHideMapList();
         }
         
         else if(IsSubStr(response, "admin_maps_selectgt_" ) && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_mapcontrol"]))) 
         {
            self thread maps\mp\gametypes\_admin::selectGametype(response);
         }
         else if(IsSubStr(response, "admin_maps_selectmap_" ) && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_mapcontrol"]))) 
         {
            self thread maps\mp\gametypes\_admin::selectMap(response);
         }
         else if(response == "admin_maps_reset" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_mapcontrol"])))
         {
            self thread maps\mp\gametypes\_admin::resetMap();
         }
         else if(response == "admin_maps_rotate" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_mapcontrol"])))
         {
            self thread maps\mp\gametypes\_admin::mapRotate();
         }
         else if(response == "admin_maps_togglecustoms" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_mapcontrol"])))
         {
            self thread maps\mp\gametypes\_admin::toggleCustomMapList();
         }
         
         
         //=================================//
         
         else if(response == "admin_togglematchmode" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_matchmode"])))
         {
            self closeMenu();
            self closeInGameMenu();

            if(game["isMatch"])
               setdvar("bro_match",0);    
            else
               setdvar("bro_match",1);       
         }
         
         else if(response == "admin_setmatch_tcl" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_matchmode"])))
         {
            self closeMenu();
            self closeInGameMenu();

            if(game["isMatch"])
               setdvar("bro_match",0);    
            else
               setdvar("bro_match","tcl");  
         }
         
         else if(response == "setDefendersAllies" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_matchmode"])))
         {
            self closeMenu();
            self closeInGameMenu();
            
            setdvar("bro_defenders","allies");
         }
         
         else if(response == "setDefendersAxis" && (isDefined(self.pers["admin_all"]) || isDefined(self.pers["admin_matchmode"])))
         {
            self closeMenu();
            self closeInGameMenu();

            setdvar("bro_defenders","axis");
         }
         
         
      }
//===========   END ADMIN   ==========//		

//===========  START SQUAD  ==========//	
      
      if(menu == "squadloadout_american")
      {
         if(response == "squadclosed")
         {
            self notify("kill_squad_thread");
         }
         else if(response == "squadmenu_shownames")
         {
            self thread maps\mp\gametypes\_squadloadout::showNames();
         }
         else if(response == "squadmenu_hidenames")
         {
            self thread maps\mp\gametypes\_squadloadout::hideNames();
         }
         else if(response == "confirmsquad_loadout")
         {
            self thread maps\mp\gametypes\_squadloadout::loadout_confirm();    
         }
         else if(issubstr(response,"selectsquad_"))
         {
            self thread maps\mp\gametypes\_squadloadout::squad_select(response);
         }
         else if(issubstr(response,"selectclass_"))
         {
            self thread maps\mp\gametypes\_squadloadout::class_select(response);
         }
         else if(issubstr(response,"selectweapon_"))
         {
            self thread maps\mp\gametypes\_squadloadout::weapon_select(response);
         }       
      }
//===========  END SQUAD  ==========//	

//===========  START CLASS  ==========//	
      
      if(menu == "squadloadout_ro")
      {
         if(response == "classclosed")
         {
            self notify("kill_class_thread");
         }
   //      else if(response == "classmenu_shownames")
    //     {
   //         self thread maps\mp\gametypes\_squadloadout::showNames();
   //      }
   //      else if(response == "classmenu_hidenames")
   //      {
   //         self thread maps\mp\gametypes\_squadloadout::hideNames();
  //       }
         else if(response == "confirmclass_loadout")
         {
            self thread maps\mp\gametypes\_classloadout::loadout_confirm();    
         }
         else if(issubstr(response,"selectclass_"))
         {
            self thread maps\mp\gametypes\_classloadout::class_select(response);
         }
         else if(issubstr(response,"selectweapon_"))
         {
            self thread maps\mp\gametypes\_classloadout::weapon_select(response);
         }       
      }
//===========  END CLASS  ==========//	

		if(response == "showsquadinfo")
		{
         if(!level._squadsAutoJoin)
            self [[level.showsquadinfo]]();
		}

		
		if(response == "leavesquad")
		{
         if(!level._squadsAutoJoin)
         {
            self closeMenu();
            self [[level.leavesquad]]();
			}
		}

		if(response == "joinsquad")
		{
         if(!level._squadsAutoJoin)
            self [[level.joinsquad]]();
		}
		
		if(response == "createsquad")
		{
         if(!level._squadsAutoJoin)
            self [[level.createsquad]]();
		}

		if(response == "locksquad")
		{
         if(!level._squadsAutoJoin)
         {
            self closeMenu();
            self [[level.locksquad]]();
         }
		}
		
		if(response == "unlocksquad")
		{
         if(!level._squadsAutoJoin)
         {
            self closeMenu();
            self [[level.unlocksquad]]();
			}
		}
		
		if(response == "showwelcome")
		{
         self closeMenu();
         self closeInGameMenu();
         self openMenu(game["menu_welcome"]);
         self setClientDvars("ui_showclickcontinue" , 1);
		}
		
		if(response == "changeteam")
		{
			self closeMenu();
			self closeInGameMenu();
			self openMenu(game["menu_team"]);
		}
	
		if(response == "changeclass_marines" )
		{
         if(level.squadSystem["active"] > 0)
         {
            if(level.squadSystem["active"] == 1)
            {
               self thread maps\mp\gametypes\_squadloadout::menuLoad();
               self closeMenu();
               self closeInGameMenu();
               self openMenu("squadloadout_american");
            }
            else
            {
               self thread maps\mp\gametypes\_classloadout::menuLoad();
               self closeMenu();
               self closeInGameMenu();
               self openMenu("squadloadout_ro");  
            }
         }
         else
         {
            self thread maps\mp\gametypes\_weaponlimiter::setWeaponUIPlayer();
         
            self closeMenu();
            self closeInGameMenu();
            self openMenu( game["menu_changeclass_allies"] );
         }
			continue;
		}

		if(response == "changeclass_opfor" )
		{
         if(level.squadSystem["active"] > 0)
         {
            if(level.squadSystem["active"] == 1)
            {
               self thread maps\mp\gametypes\_squadloadout::menuLoad();
               self closeMenu();
               self closeInGameMenu();
               self openMenu("squadloadout_american");
            }
            else
            {
               self thread maps\mp\gametypes\_classloadout::menuLoad();
               self closeMenu();
               self closeInGameMenu();
               self openMenu("squadloadout_ro");
            }
         }
         else
         {
            self closeMenu();
            self thread maps\mp\gametypes\_weaponlimiter::setWeaponUIPlayer();
			
            self closeInGameMenu();
            self openMenu( game["menu_changeclass_axis"] );
			}
			continue;
		}

		if(response == "changeclass_marines_splitscreen" )
			self openMenu( "changeclass_marines_splitscreen" );

		if(response == "changeclass_opfor_splitscreen" )
			self openMenu( "changeclass_opfor_splitscreen" );
					
		// rank update text options
		if(response == "xpTextToggle")
		{
			self.enableText = !self.enableText;
			if (self.enableText)
				self setClientDvar( "ui_xpText", "1" );
			else
				self setClientDvar( "ui_xpText", "0" );
			continue;
		}

		// 3D Waypoint options
		if(response == "waypointToggle")
		{
			self.enable3DWaypoints = !self.enable3DWaypoints;
			if (self.enable3DWaypoints)
				self setClientDvar( "ui_3dwaypointtext", "1" );
			else
				self setClientDvar( "ui_3dwaypointtext", "0" );
//			self maps\mp\gametypes\_objpoints::updatePlayerObjpoints();
			continue;
		}

		// 3D death icon options
		if(response == "deathIconToggle")
		{
			self.enableDeathIcons = !self.enableDeathIcons;
			if (self.enableDeathIcons)
				self setClientDvar( "ui_deathicontext", "1" );
			else
				self setClientDvar( "ui_deathicontext", "0" );
			self maps\mp\gametypes\_deathicons::updateDeathIconsEnabled();
			continue;
		}
		
		if(response == "endgame")
		{
			// TODO: replace with onSomethingEvent call 
			if(level.splitscreen)
			{
				if ( level.console )
					endparty();
				level.skipVote = true;

				if ( !level.gameEnded )
				{
					level thread maps\mp\gametypes\_globallogic::forceEnd();
				}
			}
				
			continue;
		}

		if ( response == "endround" )
		{
         if(level.splitscreen)
			{
            if ( !level.gameEnded )
            {
               level thread maps\mp\gametypes\_globallogic::forceEnd();
            }
            else
            {
               self closeMenu();
               self closeInGameMenu();
               self iprintln( &"MP_HOST_ENDGAME_RESPONSE" );
            }		
         }
			continue;
		}

		if(menu == game["menu_team"])
		{
         
   /*      if(getdvar("bro_forceAutoAssign") == "1")
         {
            if(response != "spectator")
               response = "autoassign";         
         }
       */         
			switch(response)
			{
			case "allies":
				//self closeMenu();
				//self closeInGameMenu();
				
				self [[level.leavesquad]]();
				
				validTeam = self maps\mp\gametypes\_mod_core::checkClanTeam("allies");
				 
				
				self [[level.allies]]();
				
				if(level.squadSystem["active"] <= 0)      
               self thread maps\mp\gametypes\_weaponlimiter::setWeaponUIPlayer();
               
				break;

			case "axis":
				//self closeMenu();
				//self closeInGameMenu();
				
				self [[level.leavesquad]]();
				self [[level.axis]]();
				if(level.squadSystem["active"] <= 0)    
               self thread maps\mp\gametypes\_weaponlimiter::setWeaponUIPlayer();
				break;

			case "autoassign":
            
				//self closeMenu();
				//self closeInGameMenu();
				self [[level.leavesquad]]();
				self [[level.autoassign]]();
				if(level.squadSystem["active"] <= 0)    
               self thread maps\mp\gametypes\_weaponlimiter::setWeaponUIPlayer();
				break;

			case "spectator":
				//self closeMenu();
				//self closeInGameMenu();
				self [[level.leavesquad]]();
				self [[level.spectator]]();
				break;
			}
		}	// the only responses remain are change class events
		else if( (menu == game["menu_changeclass"] || menu == game["menu_changeclass_offline"] || menu == game["menu_changeclass_allies"] || menu == game["menu_changeclass_axis"] ) && 
		(level.squadSystem["active"] <= 0 || (isDefined(self.pers["isBot"]) && self.pers["isBot"] == true)))
		{
        // self thread maps\mp\gametypes\_mod_core::setWeaponUIPlayer();
	//		self closeMenu();
			self closeInGameMenu();

			self.selectedClass = true;
			self [[level.class]](response);
		}
		else if (menu == "welcome")
      {
              // self closeMenu();
         if(self.pers["team"] == "spectator")
         {
            self openMenu(game["menu_team"]);
         }
         else
         {
            self openMenu(game["menu_class"]);
         }
		}
		else if(level.squadSystem["active"] > 0 && response == "shoutformedic")
		{
         
            self thread maps\mp\gametypes\_medics::shoutForMedic();
         
		}
/*		else if(level.squadSystem["active"] > 0 && response == "quickmessage_open" && isDefined(self.medicPromptOnscreen))
		{


      //      self thread maps\mp\gametypes\_medics::shoutForMedic();
            self thread maps\mp\_utility::ExecClientCommand("openscriptmenu radio shoutformedic");         
		} */
		else if ( !level.console )
		{
			if(menu == game["menu_quickcommands"])
				maps\mp\gametypes\_quickmessages::quickcommands(response);
			else if(menu == game["menu_quickstatements"])
				maps\mp\gametypes\_quickmessages::quickstatements(response);
			else if(menu == game["menu_quickresponses"])
				maps\mp\gametypes\_quickmessages::quickresponses(response);
		}
		
		
	
	}
}

